<?php
/**
 * @version $Id: D3pipesBlockWeblogd3list.class.php 139 2007-09-13 04:11:00Z hodaka $
 * @brief d3pipes plugin for weblogD3 module
 * @@author Takeshi Kuriyama <kuri@keynext.co.jp>
 */

require_once dirname(dirname(__FILE__)).'/D3pipesBlockAbstract.class.php' ;

class D3pipesBlockWeblogd3list extends D3pipesBlockAbstract {

    var $target_dirname = '';
    var $trustdirname = 'weblogD3';

    function init()
    {
        // parse and check option for this class
        $params = array_map( 'trim' , explode( '|' , $this->option ) ) ;
        if( empty( $params[0] ) ) {
            $this->errors[] = _MD_D3PIPES_ERR_INVALIDDIRNAMEINBLOCK."\n($this->pipe_id)" ;
            return false ;
        }
        $this->target_dirname = preg_replace( '/[^0-9a-zA-Z_-]/' , '' , $params[0] );
        $this->trustdirname = 'weblogD3';

        // configurations (file, name, block_options)
        $this->func_file = XOOPS_ROOT_PATH.'/modules/'.$this->target_dirname.'/blocks/blocks.php' ;
        $this->func_name = 'b_'.$this->trustdirname.'_recent_blogs_show';
        $this->block_options = array(
            'disable_renderer' => true,
            0 => $this->target_dirname, // mydirname of d3blog
            1 => empty( $params[1] ) ? 10 : intval( $params[1] ), // number of entries to show
            2 => 25, // max length of the title
            3 => 'Y/m/d', // date format
            4 => 0,  // show avatar(1:yes 0:no)
            5 => 1, // type
            6 => 0,   // link
            7 => 1,   // show contents
            8 => 100, // max length of entry.(0:no limits)
            10 => 1 // return data(1:yes 0:no) 
        ) ;

        return true ;
    }

    function reassign( $data )
    {
//        $data = $this->unhtmlspecialchars( $data ) ; // d3 modules has a rule assigning escaped variables
        $entries = array();
        if(is_array($data)) {
        	foreach( $data['entries'] as $item ) {
            	$entry = array(
                	'pubtime' => $item['created'], // unix timestamp
                	'link' => $item['entry_url'],
                	'headline' => $this->unhtmlspecialchars( $item['title'] ),
                	'description' => $this->unhtmlspecialchars( $item['contents'] ),
                	'allow_html' => false,
            	);
            	$entry['fingerprint'] = $entry['link'] ;
            	$entries[] = $entry ;
        	}
        }
        return $entries ;
    }

}

?>