<?php
/**
 * @version $Id: importmanager.php 314 2007-07-08 12:46:27Z hodaka $
 */

$thistrustdirname = basename(dirname(__FILE__ ));

require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once dirname(dirname(__FILE__)).'/include/admin.inc.php';
require_once dirname(dirname(__FILE__)).'/include/gtickets.php' ;

$myts =& MyTextSanitizer::getInstance() ;
$db =& Database::getInstance() ;

$module_handler =& xoops_gethandler( 'module' ) ;
$config_handler =& xoops_gethandler('config');

$mymid = $xoopsModule->getVar('mid');
$mod_config =& $config_handler->getConfigsByCat(0,$mymid);
$my_photodir = !empty($mod_config['weblog_myalbum_photospath'])?$mod_config['weblog_myalbum_photospath']:'';
$my_thumbdir = !empty($mod_config['weblog_myalbum_thumbspath'])?$mod_config['weblog_myalbum_thumbspath']:'';
unset($mod_config);

$modules =& $module_handler->getObjects() ;
$comment_handler =& xoops_gethandler( 'comment' ) ;

$importable_modules = array() ;
$comimportable_modules = array() ;
$movable_image_modules = array();
$importable_modules[0] = $comimportable_modules[0] = $movable_image_modules[0] = _MD_A_WEBLOG_LANG_SELECT_IMPORTMODULE;

foreach( $modules as $module ) {
    $mid = $module->getVar('mid') ;
    $dirname = $module->getVar('dirname') ;
    $dirpath = XOOPS_ROOT_PATH.'/modules/'.$dirname ;
    $mytrustdirname = '' ;
    $modconfig =& $config_handler->getConfigsByCat(0,$mid);
    if( file_exists( $dirpath.'/mytrustdirname.php' ) ) {
        require $dirpath.'/mytrustdirname.php' ;
        if( $mytrustdirname != '' && $dirname != $mydirname && isset($modconfig['use_permissionsystem'])) {
            // weblogD3 type
            $importable_modules[$mid] = $mytrustdirname.':'.$module->getVar('name')."($dirname)";
            if($module->getVar('hascomments')) {
                $comimportable_modules[ $mid ] = $mytrustdirname.":".$module->getVar('name')." ($dirname)" ;
            }
            if($modconfig['use_imagemanager']) {
                $photodir = isset($modconfig['weblog_myalbum_photospath'])?$modconfig['weblog_myalbum_photospath']:'';
                $thumbdir = isset($modconfig['weblog_myalbum_thumbspath'])?$modconfig['weblog_myalbum_thumbspath']:'';
                $photo_sum = count_photo($photodir);
                $thumb_sum = count_photo($thumbdir);
                if($photo_sum>0 || $thumb_sum>0) {
                    $movable_image_modules[ $mid ] = $mytrustdirname.":".$module->getVar('name')." ($dirname)" ;
                }
            }
        }
    } elseif(preg_match('/^weblog(\d?)$/', $dirname, $matches)) {
        // weblog
        $importable_modules[$mid] = 'weblog:'.$module->getVar('name')."($dirname)" ;
        if($module->getVar('hascomments')) {
            $comimportable_modules[ $mid ] = "weblog:".$module->getVar('name')." ($dirname)" ;
        }
        if($modconfig['use_imagemanager']) {
            $photodir = isset($modconfig['weblog_myalbum_photospath'])?$modconfig['weblog_myalbum_photospath']:'';
            $thumbdir = isset($modconfig['weblog_myalbum_thumbspath'])?$modconfig['weblog_myalbum_thumbspath']:'';

            $photo_sum = count_photo($photodir);
            $thumb_sum = count_photo($thumbdir);
            if($photo_sum>0 || $thumb_sum>0) {
                $movable_image_modules[ $mid ] = "weblog:".$module->getVar('name')." ($dirname)" ;
            }
        }
    }
}

if( ! empty( $_POST['do_import'] ) && ! empty( $_POST['import_mid'] ) ) {
    set_time_limit( 0 ) ;

    if ( ! $xoopsGTicket->check( true , 'weblogD3_admin' ) ) {
        redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
    }

    $import_mid = intval( @$_POST['import_mid'] ) ;
    if( empty( $importable_modules[ $import_mid ] ) ) die( _MD_A_WEBLOG_ERR_INVALIDMID ) ;
    list( $fromtype , $from_name) = explode( ':' , $importable_modules[ $import_mid ] ) ;
    preg_match('/([A-Za-z0-9_-]+)\)$/i', $from_name, $matches);
    $import_dirname = $matches[1];

    if($fromtype=='weblog')
        import_from_weblog( $import_dirname , $import_mid );
    else
        import_from_weblogD3( $import_dirname , $import_mid );
    //rewrite_linkpath("modules/$import_dirname", "modules/$mydirname");

    redirect_header( XOOPS_URL."/modules/$mydirname/admin/index.php?page=importmanager" , 30, _MD_A_WEBLOG_MSG_IMPORTDONE._MD_A_WEBLOG_MSG_MIGHT_REWRITE_LINKPATH ) ;
    exit ;
}

if( ! empty( $_POST['do_comimport'] ) && ! empty( $_POST['comimport_mid'] ) ) {
    set_time_limit( 0 ) ;

    if ( ! $xoopsGTicket->check( true , 'weblogD3_admin' ) ) {
        redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
    }

    $import_mid = intval( @$_POST['comimport_mid'] ) ;
    if( !in_array( $import_mid, array_keys($comimportable_modules)) ) die( _MD_A_WEBLOG_ERR_INVALIDMID ) ;
    list( $fromtype , $from_name) = explode( ':' , $comimportable_modules[ $import_mid ] ) ;

    preg_match('/([A-Za-z0-9_-]+)\)$/i', $from_name, $matches);
    $import_dirname = $matches[1];

    import_comments($mymid, $import_mid);
    synchronizeComments($mydirname.'_entry', $mymid);
    if($fromtype == 'weblog') synchronizeComments($import_dirname, $import_mid);
    else synchronizeComments($import_dirname.'_entry', $import_mid);
    rewrite_compath("/modules/$import_dirname/", "/modules/$mydirname/");
    import_notifications($mymid, $import_mid, $fromtype);

    redirect_header( XOOPS_URL."/modules/$mydirname/admin/index.php?page=importmanager" , 3 , _MD_A_WEBLOG_MSG_IMPORTDONE ) ;
    exit ;
}

if( ! empty( $_POST['do_imageimport'] ) && ! empty( $_POST['imageimport_mid'] ) ) {
    set_time_limit( 0 ) ;

    if ( ! $xoopsGTicket->check( true , 'weblogD3_admin' ) ) {
        redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
    }

    $import_mid = intval( @$_POST['imageimport_mid'] ) ;
    if( !in_array( $import_mid, array_keys($movable_image_modules)) ) die( _MD_A_WEBLOG_ERR_INVALIDMID ) ;
    $modconf =& $config_handler->getConfigsByCat(0,$import_mid);
    list( $fromtype , $from_name) = explode( ':' , $movable_image_modules[ $import_mid ] ) ;

    switch( $fromtype ) {
        case 'weblog' :
            $from_photodir = !empty($modconf['weblog_myalbum_photospath'])?$modconf['weblog_myalbum_photospath']:'';
            $from_thumbdir = !empty($modconf['weblog_myalbum_thumbspath'])?$modconf['weblog_myalbum_thumbspath']:'';
            break ;
        case 'weblogD3' :
        default:
            $from_photodir = !empty($modconf['weblog_myalbum_photospath'])?$modconf['weblog_myalbum_photospath']:'';
            $from_thumbdir = !empty($modconf['weblog_myalbum_thumbspath'])?$modconf['weblog_myalbum_thumbspath']:'';
            break ;
    }

    $photo_count = $thumb_count = 0;
    if(!empty($from_photodir))
        $photo_count = move_photo($from_photodir, $my_photodir);
    if(!empty($from_thumbdir))
        $thumb_count = move_photo($from_thumbdir, $my_thumbdir);

    $pattern = array($from_photodir, $from_thumbdir);
    $replacement = array($my_photodir, $my_thumbdir);
    rewrite_imglinkpath($pattern, $replacement);

    redirect_header( XOOPS_URL."/modules/$mydirname/admin/index.php?page=importmanager" , 30 ,
        sprintf(_MD_A_WEBLOG_MSG_IMAGEIMPORTDONE, $photo_count, $thumb_count )) ;
    exit ;
}

if( ! empty( $_POST['do_synchronize'] ) ) {
    set_time_limit( 0 ) ;

    if ( ! $xoopsGTicket->check( true , 'weblogD3_admin' ) ) {
        redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
    }

    synchronizeComments($mydirname.'_entry', $mymid);
    synchronizeTrackbacks($mydirname);

    redirect_header( XOOPS_URL."/modules/$mydirname/admin/index.php?page=importmanager" , 3 , _MD_A_WEBLOG_MSG_IMPORTDONE ) ;
    exit ;
}

//
// display stage
//

xoops_cp_header();
include dirname(__FILE__).'/mymenu.php' ;
$tpl =& new XoopsTpl() ;
$tpl->assign( array(
    'mymid' => $mymid,
    'mydirname' => $mydirname ,
    'mod_url' => XOOPS_URL.'/modules/'.$mydirname ,
    'import_from_options' => $importable_modules ,
    'comimport_from_options' => $comimportable_modules ,
    'move_from_options' => $movable_image_modules ,
    'new_photodir' => $myts->htmlSpecialChars($my_photodir) ,
    'new_thumbdir' => $myts->htmlSpecialChars($my_thumbdir) ,
    'gticket_hidden' => $xoopsGTicket->getTicketHtml( __LINE__ , 1800 , 'weblogD3_admin') ,
) ) ;
$tpl->display( 'db:'.$mydirname.'_admin_importmanager.html' ) ;
xoops_cp_footer();




?>