<?php
/**
 * @version $Id: weblogD3commentEntry.class.php 120 2007-08-17 06:21:44Z hodaka $
 * @author Takeshi Kuriyama <kuri@keynext.co.jp>
 * @package a class for d3forum comment integration
 */
 
class weblogD3commentEntry extends D3commentAbstract {

function fetchSummary($external_link_id)
{
    $db =& Database::getInstance();
    $myts =& MyTextsanitizer::getInstance();

    $module_handler =& xoops_gethandler( 'module' );
    $module =& $module_handler->getByDirname( $this->mydirname );
    $config_handler =& xoops_gethandler( 'config' );
    $moduleConfig =& $config_handler->getConfigList($module->mid());

    global $xoopsUser;
    $currentuid = is_object($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

    if( preg_match( '/[^0-9a-zA-Z_-]/' , $this->mydirname ) ) die( 'Invalid mydirname' );

    $return['dirname'] = $myts->htmlspecialchars($this->mydirname, ENT_QUOTES);
    $return['module_name'] = $module->name();
    $return['uri'] = sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $this->mydirname, intval($external_link_id));
    $return['subject'] = '';
    $return['summary'] = '';
    
    include dirname(dirname(__FILE__)).'/include/config.php';
    list( $bl_contents_field , $permission_group_sql ) = weblog_create_permissionsql($moduleConfig, $this->mydirname);

    $sql = sprintf('SELECT * FROM %s WHERE blog_id=%d AND (user_id=%d OR (private ="N" AND created < %d)) %s',
        $db->prefix($this->mydirname.'_entry'), intval($external_link_id), $currentuid, time(), $permission_group_sql);

    $result =& $db->query($sql);
    if($result) {
        $row =& $db->fetchArray($result);
        $return['subject'] = htmlspecialchars($row['title'], ENT_QUOTES);

        $contents = $myts->displayTarea(strip_tags($row['contents']), intval($row['dohtml']), 1, 1, 1, intval($row['dobr']));

        // menber only
        if( isset($moduleConfig['use_memberonly']) && $moduleConfig['use_memberonly'] && $currentuid <= 0 ) {
            $arr = explode(MEMBER_ONLY_READ_DELIMETER, $contents);
            $contents = $arr[0];
        }else{
            $contents = str_replace( MEMBER_ONLY_READ_DELIMETER , "" , $contents ) ;
        }
    
        // entry division separator
        if( isset($moduleConfig['use_separator']) && $moduleConfig['use_separator'] ) {
            $arr = explode(_MD_WEBLOG_ENTRY_SEPARATOR_DELIMETER, $contents);
            $contents = $arr[0];
        }else{
            $contents = str_replace( _MD_WEBLOG_ENTRY_SEPARATOR_DELIMETER , "" , $contents ) ;
        }
        
        $return['summary'] = xoops_substr(strip_tags($contents), 0, WEBLOG_RDF_DESCRIPTION_NUM);
    }

    return $return;
}

function validate_id( $link_id )
{
    $blog_id = intval($link_id);
    if($link_id <= 0)
        return false;
    
    $db =& Database::getInstance() ;

    $sql = sprintf('SELECT COUNT(*) FROM %s WHERE blog_id=%d', $db->prefix($this->mydirname.'_entry'), $blog_id);

    list($count) = $db->fetchRow($db->query($sql));
    if( $count <= 0 ) return false ;
    else return $blog_id;
}

}
?>