<?php
/*
 * $Id: admin.inc.php 296 2007-06-21 16:03:33Z hodaka $
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
if( ! defined( 'XOOPS_ROOT_PATH' ) ) exit ;

function indexLink() {
    global $xoopsModule;

    return sprintf('<a href=\'%s/modules/%s/admin/index.php\'>%s</a>',
                   XOOPS_URL, $xoopsModule->dirname(), _MD_A_WEBLOG_CONFIG);
}

function tableRow($title, $description, $action='', $hidden=array()) {
    $html = sprintf("<tr valign='top' align='left'><td class='head'>%s<br /><br /><span style='font-weight:normal;'>%s</span></td>",
                    $title, $description);
    if ($action!='') {
        $html .= "<td class='even'><form method='post' action='dbmanager.php'>\r\n";
        $html .= sprintf("<input type='hidden' name='action' value='%s' />", $action);
        if (count($hidden)>0) {
            foreach ($hidden as $p) {
                $html .= sprintf("<input type='hidden' name='param[]' value='%s'/>", $p);
            }
        }
        $html .= sprintf("<input type='submit' class='formButton' name='button'  value='%s'/>", _MD_A_WEBLOG_GO);
        $html .= "</form>";
    }
    $html .= "</td></tr>\r\n";

    return $html;
}

function import_from_weblog( $from_prefix , $import_mid )
{
    global $mydirname;
    $db =& Database::getInstance() ;

    // entry
    $table_name = 'entry' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // category
    $table_name = 'category' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // entry
    $table_name = 'priv' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // trackback
    $table_name = 'trackback' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
/*        $rs = $db->query("SELECT * FROM `$from_table` LIMIT 1");
        if(mysql_num_fields($rs) < 9) {
            $atrs = $db->query("ALTER TABLE `$from_table` ADD `tbkey` VARCHAR( 12 ) NOT NULL");
            if( ! $atrs ) import_errordie() ;
        }*/
        if($sre = $db->query("SHOW COLUMNS FROM `$from_table` LIKE 'tbkey'")) {
            if(!$row = $db->fetchRow($sre))
                if(!$are = $db->query("ALTER TABLE `$from_table` ADD `tbkey` VARCHAR( 12 ) NOT NULL")) import_errordie() ;
        }

        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
        make_tbkey($to_table);
    }

    // photo
    $table_name = 'photo' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'myalbum_'.$table_name.'s' ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

}

function import_from_weblogD3( $from_prefix , $import_mid )
{
    global $mydirname;
    $db =& Database::getInstance() ;

    // entry
    $table_name = 'entry' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // category
    $table_name = 'category' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // entry
    $table_name = 'priv' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

    // trackback
    $table_name = 'trackback' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;

    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
/*        $rs = $db->query("SELECT * FROM `$from_table` LIMIT 1");
        if(mysql_num_fields($rs) < 9) {
            $atrs = $db->query("ALTER TABLE `$from_table` ADD `tbkey` VARCHAR( 12 ) NOT NULL");
            if( ! $atrs ) import_errordie() ;
        }*/
        if($sre = $db->query("SHOW COLUMNS FROM `$from_table` LIKE 'tbkey'")) {
            if(!$row = $db->fetchRow($sre))
                if(!$are = $db->query("ALTER TABLE `$from_table` ADD `tbkey` VARCHAR( 12 ) NOT NULL AFTER `traclback_created`")) import_errordie() ;
        }
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
        make_tbkey($to_table);
    }

    // photo
    $table_name = 'photo' ;
    $to_table = $db->prefix( $mydirname.'_'.$table_name ) ;
    $from_table = $db->prefix( $from_prefix.'_'.$table_name ) ;
    $db->query( "DELETE FROM `$to_table`" ) ;
    if($res = $db->query("SELECT count(*) as count FROM `$from_table` WHERE 1")) {
        $irs = $db->query("INSERT INTO `$to_table` SELECT * FROM `$from_table`" );
        if( ! $irs ) import_errordie() ;
    }

}

function import_comments($to_mid, $from_mid)
{
    $db =& Database::getInstance();
    $sql = sprintf("UPDATE `%s` SET com_modid=%d WHERE com_modid=%d",
        $db->prefix('xoopscomments'), intval($to_mid), intval($from_mid));
    if(!$irs = $db->query($sql)) {
        import_errordie() ;
    }
}

function import_notifications($to_mid, $from_mid, $fromtype)
{
    global $mydirname;
    $db =& Database::getInstance();

    if(!$result = $db->query("SELECT not_id, not_category FROM ".$db->prefix('xoopsnotifications'). " WHERE not_modid='$from_mid'"))
        return true;
    $replacement = array('blog'=>'blogger', 'blog_entry'=>'detail');
    while( list($not_id, $category) = $db->fetchRow($result) ) {
        $sql = "UPDATE ".$db->prefix('xoopsnotifications')." SET not_modid='$to_mid'";
        if($fromtype == 'weblog') {
            $sql .= ", not_category='".$replacement[$category]."'";
        }
        $sql .= " WHERE not_id='$not_id'";
        if(!$irs = $db->query($sql)) {
            import_errordie() ;
        }
    }
}

function synchronizeComments($tablename, $mid) {
    $db =& Database::getInstance() ;

    $sql = sprintf("UPDATE %s SET comments='0' WHERE 1", $db->prefix($tablename));
    if (!$re = $db->query($sql)) {
        import_errordie();
    }

    $sql = sprintf("SELECT e.blog_id, COUNT(c.com_id) FROM `%s` AS e LEFT JOIN `%s` AS c ON e.blog_id=c.com_itemid AND c.com_modid=%d GROUP BY e.blog_id",
                   $db->prefix($tablename), $db->prefix('xoopscomments'), intval($mid));
    if(!$result = $db->query($sql))     return true;

    while (list($blog_id, $comments) = $db->fetchRow($result)) {
        $sql = sprintf("UPDATE `%s` SET comments=%d WHERE blog_id=%d", $db->prefix($tablename),
                       intval($comments), intval($blog_id));
        if (!$re = $db->query($sql)) {
            import_errordie();
        }
    }

    return true;
}

function synchronizeTrackbacks($dirname) {
    $db =& Database::getInstance();

    $sql = sprintf("UPDATE %s SET trackbacks='0' WHERE 1", $db->prefix($dirname.'_entry'));
    if (!$re = $db->query($sql)) {
        import_errordie();
    }

    $sql = sprintf("SELECT blog_id, COUNT(*) FROM %s WHERE direction='received' AND tb_url<>tbkey GROUP BY blog_id",
                   $db->prefix($dirname.'_trackback'));
    if(!$result = $db->query($sql))     return true;

    while (list($blog_id, $trackbacks) = $db->fetchRow($result)) {
        $sql = sprintf("UPDATE %s SET trackbacks=%d WHERE blog_id=%d",
                       $db->prefix($dirname.'_entry'), intval($trackbacks), intval($blog_id));
        if (!$re = $db->query($sql)) {
            import_errordie();
        }
    }

    return true;
}

function import_errordie()
{
    $db =& Database::getInstance() ;

    echo _MD_A_WEBLOGD3_ERR_SQLONIMPORT ;
    echo $db->logger->dumpQueries() ;
    exit ;
}

function rewrite_linkpath($pattern, $replacement)
{
    global $mydirname;
    $db =& Database::getInstance();
    $myts =& MyTextSanitizer:: getInstance();

    if(!$result = $db->query("SELECT blog_id, contents FROM ".$db->prefix($mydirname.'_entry')." WHERE 1")) die($db->prefix($mydirname.'_entry')." Not found");
    while(list($blog_id, $contents) = $db->fetchRow($result)) {
        $contents2 = str_replace($pattern, $replacement, $contents);
        if($contents2 != $contents) {
            $sql = sprintf("UPDATE `%s` SET contents='%s' WHERE blog_id=%d",
                       $db->prefix($mydirname.'_entry'), $myts->addSlashes($contents2), intval($blog_id));
            if (!$res = $db->query($sql)) import_errordie();
        }
    }
}

function rewrite_compath($pattern, $replacement)
{
    global $mymid;
    $db =& Database::getInstance();
    $myts =& MyTextSanitizer:: getInstance();

    $sql = "SELECT com_id, com_text FROM ".$db->prefix('xoopscomments')." WHERE com_modid='$mymid'";

    if(!$result = $db->query($sql)) return true;
    while(list($com_id, $com_text) = $db->fetchRow($result)) {
        $com_text2 = str_replace($pattern, $replacement, $com_text);
        if($com_text2 != $com_text) {
            $sql = sprintf("UPDATE %s SET com_text='%s' WHERE com_id=%d",
                       $db->prefix('xoopscomments'), $myts->addSlashes($com_text2), intval($com_id));
            if (!$res = $db->query($sql)) import_errordie();
        }
    }
}

function count_photo($from_dir)
{
    if($from_dir != "" && !preg_match("/^\/(.+)$/i", $from_dir)) {
                $from_dir = "/".$from_dir;
    }
    $k = 0;
    if ($handle = opendir(XOOPS_ROOT_PATH.$from_dir)) {
        while (false !== ($file = readdir($handle))) {
            if ($file != "." && $file != "..") {
                $k++;
            }
        }
        closedir($handle);
    }
    return $k;
}

function move_photo($from_dir, $to_dir)
{
    $from_dir = XOOPS_ROOT_PATH.$from_dir;
    $to_dir = XOOPS_ROOT_PATH.$to_dir;

    if(!checkDir($to_dir)) die(htmlspecialchars($to_dir)." id not be available.");

    if($from_dir != "" && !preg_match("/^(.+)\/$/i", $from_dir)) {
                $from_dir .= "/";
    }
    if($to_dir != "" && !preg_match("/^(.+)\/$/i", $to_dir)) {
                $to_dir .= "/";
    }

    $k = 0;
    if ($handle = opendir($from_dir)) {
        while (false !== ($file = readdir($handle))) {
            if ($file != "." && $file != "..") {
                copy($from_dir.$file, $to_dir.$file);
                if( !is_readable( $to_dir.$file ) ) {
                    die('Failed to copy '.htmlspecialchars($from_dir).' to '.htmlspecialchars($to_dir));
                }
                @unlink( $from_dir.$file );
                $k++;
            }
        }
        closedir($handle);
        if ( !rmdir( $from_dir ) ) {
            die(htmlspecialchars($from_dir).' could not be removed. Check the permission.');
        }
    }

    if($k == 0) {
        // No image found
        die('UPLOADED FILE NOT FOUND');
    }
    return $k;
}

function checkDir($dir) {
    if(!is_dir($dir)) {
        // safe_mode or not
        $safe_mode_flag = ini_get( "safe_mode" );
        if( $safe_mode_flag ) {
            die("'safe_mode' is set on. You must create new photo directories and make them writable.");
        }
        if ( !mkdir( $dir , 0777 ) ) {
                die(htmlspecialchars($dir).' could not be created. Check the permission of upper directories');
        }
    }

    if (!is_writeable($dir)) {
        if(!chmod( $dir , 0777 )) {
            die(sprintf("Can't chmod to be writable : %s",htmlspecialchars($dir)));
        }
    }
    return true;
}

function rewrite_imglinkpath($pattern, $replacement)
{
    global $mydirname, $mymid;
    $db =& Database::getInstance();
    $myts =& MyTextSanitizer:: getInstance();

    if(!$result = $db->query("SELECT blog_id, contents FROM ".$db->prefix($mydirname.'_entry')." WHERE 1")) die($db->prefix($mydirname.'_entry')." Not found");
    while(list($blog_id, $contents) = $db->fetchRow($result)) {
        $contents2 = str_replace($pattern, $replacement, $contents);
        if($contents2 != $contents) {
            $sql = sprintf("UPDATE %s SET contents='%s' WHERE blog_id=%d",
                       $db->prefix($mydirname.'_entry'), $myts->addSlashes($contents2), intval($blog_id));
            if (!$res = $db->query($sql)) die("DB ERROR: Failed to rewrite $db->prefix($mydirname.'_entry')");
        }
    }

    $sql = "SELECT com_id, com_text FROM ".$db->prefix('xoopscomments')." WHERE com_mod_id='$mymid'";

    if(!$result = $db->query($sql)) return true;
    while(list($com_id, $com_text) = $db->fetchRow($result)) {
        $com_text2 = str_replace($pattern, $replacement, $com_text);
        if($com_text2 != $com_text) {
            $sql = sprintf("UPDATE %s SET com_text='%s' WHERE com_id=%d",
                       $db->prefix('xoopscomments'), $myts->addSlashes($com_text2), intval($com_id));
            if (!$res = $db->query($sql)) die("DB ERROR: Failed to rewrite $db->prefix('xoopscomments')");
        }
    }
}

function make_tbkey($table)
{
    $db =& Database::getInstance();
    $ars = $db->query("ALTER TABLE `$table` CHANGE `direction` `direction` ENUM( '', 'transmit', 'received' ) NOT NULL");
    if( ! $ars ) import_errordie() ;
    $urs = $db->query("UPDATE `$table` SET direction='received' WHERE direction IN ('','recieved')");
    if( ! $urs ) import_errordie() ;

    if(!$rs = $db->query("SELECT * FROM `$table` WHERE direction='received' AND tbkey=''"))
        return null;
    while($trackback = $db->fetchArray($rs)) {
        $tbkey = md5($trackback['trackback_created'].rand());
        $tbkey= substr(base_convert($tbkey, 16, 32),0,12);
        $sql = sprintf("UPDATE %s SET tbkey='%s', direction='%s' WHERE blog_id=%d AND tb_url='%s' AND direction='%s'",
                       $table, $tbkey, 'received', intval($trackback['blog_id']), $trackback['tb_url'], $trackback['direction']);
        if (!$res = $db->query($sql)) die("DB ERROR: Failed to rewrite ".$table);
    }
}

?>