<?php
/**
 * $Id: archive.php 315 2007-07-09 05:44:24Z hodaka $
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place
 */

require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblog.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblogcategories.php';

$language = $GLOBALS['xoopsConfig']['language'];
if (file_exists(XOOPS_ROOT_PATH."/language/$language/calendar.php")) {
	require_once XOOPS_ROOT_PATH."/language/$language/calendar.php";
} else {
	require_once XOOPS_ROOT_PATH.'/language/english/calendar.php';
}
$months_arr = array(1 => _CAL_JANUARY, 2 => _CAL_FEBRUARY, 3 => _CAL_MARCH, 4 => _CAL_APRIL, 5 => _CAL_MAY, 6 => _CAL_JUNE,
    7 => _CAL_JULY, 8 => _CAL_AUGUST, 9 => _CAL_SEPTEMBER, 10 => _CAL_OCTOBER, 11 => _CAL_NOVEMBER, 12 => _CAL_DECEMBER);

// xoopsform
include_once XOOPS_ROOT_PATH.'/class/xoopsformloader.php';

// obtain GET parameters
$user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;
$date = isset($_GET['date']) ? intval($_GET['date']): 0;	// YYYY or YYYYMM
$cat_id = isset($_GET['cat_id']) ? intval($_GET['cat_id']) : 0;
$start = isset($_GET['start']) ? intval($_GET['start']) : 0;
$numperpage = isset($_GET['numperpage'])? intval($_GET['numperpage']) : 30;

// privilege check
require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';
$isAdmin = ( isset($xoopsUser) && is_object($xoopsUser) ) ? $xoopsUser->isAdmin($xoopsModule->mid()) : false ;
if( ! $isAdmin && ! checkprivilege( 'read_index' , $xoopsModule->dirname() , $cat_id ) ){
    redirect_header(sprintf('%s/index.php', XOOPS_URL ), 2, _MD_WEBLOG_CANNOT_READ_SORRY);
    exit();
}

// obtain class instances
$weblog =& Weblog::getInstance();
$weblogcat =& WeblogCategories::getInstance();

// read all the categories
$all_categories =& $weblogcat->getObjects(null, true);

// gather all children's categories
$cat_ids = getAllChildId($all_categories, $cat_id);
array_unshift($cat_ids, $cat_id);

// Determine the user to retrieve the blog entries
if (is_object($xoopsUser)) {
    $isAdmin = $xoopsUser->isAdmin($xoopsModule->mid());
    $currentuid = $xoopsUser->getVar('uid','E');
    $useroffset = $xoopsUser->timezone() - $xoopsConfig['default_TZ'];
} else {
    $isAdmin = false;
    $currentuid = 0;
    $useroffset = $xoopsConfig['default_TZ'];
}

$subtitle = '';
if ($user_id > 0) {
    $blogOwner = new XoopsUser($user_id);
    $subtitle = sprintf(_MD_WEBLOG_ARCHIVE_FOR, $blogOwner->getVar('uname'));
}
if ($cat_id > 0) {
    if($subtitle != '')
        $subtitle .= '+';
    $subtitle .= sprintf(_MD_WEBLOG_ARCHIVE_OF_CATEGORY, $all_categories[$cat_id]->getVar('cat_title'));
}
if ($date > 0) {
    $datetitle = '';
    if(strlen(strval($date)) == 6) {
        preg_match("/(\d{4})(\d{2})/", $date, $matches);
        $datetitle = $matches[1].'/'.$matches[2];
    } elseif(strlen(strval($date)) == 4) {
        preg_match("/(\d{4})/", $date, $matches);
        $datetitle = $matches[1];
    }
    if($subtitle != '') 
        $subtitle .= '+';
    $subtitle .= sprintf(_MD_WEBLOG_ARCHIVE_OF_DATE, $datetitle);
}
$page_subtitle = _MD_WEBLOG_ARCHIVE;
if($subtitle !='') {
    $page_subtitle .= '('.$subtitle.')';
}

// specify template
$xoopsOption['template_main'] = $mydirname.'_main_archive.html';

// construct the page
// Include the page header
include(XOOPS_ROOT_PATH.'/header.php');
//$xoopsTpl->xoops_setDebugging(true);	// smarty debug

/**
 * make category select box
 */
// read all the categories
$all_categories =& $weblogcat->getObjects(null, true);
// get the permitted cat_ids
$permed = getPermedIds($all_categories);
$cat_array = getChildTreeArray($all_categories, $permed);

$catselbox = array();
$catbox = array();
$catselbox[0]['prefix'] = '';
$catselbox[0]['cat_id'] = 0;
$catselbox[0]['cat_title'] = _MD_WEBLOG_SELECT_ALL;
// for w3c
$catselbox[0]['selected'] = ($cat_id == 0)? ' selected="selected"' : '';
$i = 1;

$myts =& MyTextSanitizer::getInstance();
foreach ( $cat_array as $cat ) {
	$catselbox[$i]['prefix'] = substr(str_replace('.','--',$cat['prefix']), 2);
	$catselbox[$i]['cat_id'] = $myts->makeTboxData4Show($cat['cat_id']);
	$catselbox[$i]['cat_title'] = $myts->makeTboxData4Show($cat['cat_id']) == 0 ? "_MD_WEBLOG_SELECT_ALLCATEGORY" : $myts->makeTboxData4Show($cat['cat_title']);
	// for w3c
	$catselbox[$i]['selected'] = ($cat_id == $cat['cat_id'] )? ' selected="selected"' : '';
	$i++;
	$catbox[$cat['cat_id']] = $myts->makeTboxData4Show($cat['cat_title']);
}
$xoopsTpl->assign('catselbox', $catselbox);

/**
 * make user_id select box
 */
$blogger_id = array('' => _MD_WEBLOG_SELECT_ALL) ;
$sql = sprintf('SELECT user_id, uname from %s, %s where uid=user_id and private=\'N\' group by user_id ' ,
		$xoopsDB->prefix($mydirname.'_entry') , $xoopsDB->prefix('users')) ;
if( $uid_result = $xoopsDB->query($sql) ){
	while( $uid_uname = $xoopsDB->fetchArray($uid_result) ){
		$blogger_id[intval($uid_uname['user_id'])] = $myts->htmlSpecialChars($uid_uname['uname'], ENT_QUOTES);
	}
}

$xoopsTpl->assign('uidselarray', $blogger_id);
$xoopsTpl->assign('uidselvalue', $user_id);

/**
 * make month select box
 */
$sql = sprintf('SELECT created from %s group by left(from_unixtime(created+%d)+0,6) order by created DESC' ,
				$xoopsDB->prefix($mydirname.'_entry') , $useroffset*3600 , '%Y%') ;
$month_result = $xoopsDB->query($sql) ;
$last_year = 100000 ;
$months = array('0' => _MD_WEBLOG_SELECT_ALL) ;
while( $created_example = $xoopsDB->fetchArray($month_result) ){
	list( $this_year , $this_month ) = explode(':' , date('Y:m',$created_example['created'])) ;
	if( $last_year > $this_year ){
		$last_year = $this_year ;
		$months[$this_year] = $this_year.'&nbsp;'._MD_WEBLOG_SELECT_ALL ;
	}
	$months[$this_year.$this_month] = $this_year.'&nbsp;'.$months_arr[intval($this_month)] ;
}
$xoopsTpl->assign('dateselarray', $months);
$xoopsTpl->assign('dateselvalue', $date);

/*****************
 * Get Entries
 ****************/
$results = $weblog->getArchives($currentuid, $user_id, $date, $cat_ids, $start, $numperpage, $useroffset);
$count = $weblog->getArchivesCount($currentuid, $user_id, $date, $cat_ids, $useroffset) ;
if (count($results) > 0) {
    $xoopsTpl->assign('show_archives', true);
    $xoopsTpl->assign(makeTplVars());
} else {
	$xoopsTpl->assign('show_archives', false);
}

$xoopsTpl->assign('page_title', $xoopsModule->name());
// breadcrumbs info
$xoopsTpl->assign('page_subtitle', $page_subtitle);
$xoopsTpl->assign('mydirname', $mydirname);
// for xugj_assign.php
$breadcrumbs[] = array('name'=>$xoopsModule->name(), 'url'=>XOOPS_URL.'/modules/'.$mydirname.'/');
$breadcrumbs[] = array('name'=>_MD_WEBLOG_ARCHIVE_LIST, 'url'=>XOOPS_URL.'/modules/'.$mydirname.'/archive.php');
if($subtitle != '')
    array_push($breadcrumbs, array('name'=>$subtitle, 'url'=>''));
$xoopsTpl->assign('xoops_breadcrumbs', $breadcrumbs);


// xoops_module_header
$rss = sprintf('%s/modules/%s/backend_weblog.php', XOOPS_URL, $mydirname);
$rdf = sprintf('%s/modules/%s/weblog-rdf.php', XOOPS_URL, $mydirname);
$atom = sprintf('%s/modules/%s/weblog-atom.php', XOOPS_URL, $mydirname);
$weblog_head = sprintf('<link rel="stylesheet" type="text/css" media="all" href="%s/modules/%s/css/style.css" />'."\n" , XOOPS_URL , $mydirname );
$iearound = <<<DOC_END
<!--[if lt IE 7]>
%s
<![endif]-->\n
DOC_END;
$weblog_head .= sprintf($iearound, sprintf('<link rel="stylesheet" type="text/css" media="all" href="%s/modules/%s/css/styleIE.css" />'."\n", XOOPS_URL , $mydirname));
$weblog_head .= sprintf('<link rel="alternate" type="application/rss+xml" title="RSS2.0" href="%s" />'."\n" , $rss );
$weblog_head .= sprintf('<link rel="alternate" type="application/rdf+xml" title="RDF" href="%s" />'."\n" , $rdf );
$weblog_head .= sprintf('<link rel="alternate" type="application/atom+xml" title="ATOM" href="%s" />'."\n" , $atom );
$xoopsTpl->assign('xoops_module_header', $xoopsTpl->get_template_vars('xoops_module_header').$weblog_head );

include XOOPS_ROOT_PATH."/footer.php";
	
function makeTplVars() {
	global $results, $count, $numperpage, $start;
	global $user_id, $cat_id, $mode, $catbox, $date, $useroffset;
	global $xoopsConfig, $xoopsModuleConfig;
	
	$blog['show_blogs'] = true;
	$blog['entries'] = array();
    foreach($results as $entryObject) {
		$entry = array();
		$entry['title'] = sprintf('<a href=\'detail.php?blog_id=%d\'>%s</a>',
			$entryObject->getVar('blog_id'),
			$entryObject->getVar('title','s'));
		$entry['reads'] = $entryObject->getVar('reads');
		$entry['date'] = formatTimestamp($entryObject->getVar('created')-$useroffset*3600, $xoopsModuleConfig['dateformat'], $xoopsConfig['default_TZ']);
		$entry['time'] = formatTimestamp($entryObject->getVar('created')-$useroffset*3600, $xoopsModuleConfig['timeformat'], $xoopsConfig['default_TZ']);
		$entry['uid'] = $entryObject->getVar('user_id');
		$entry['uname'] = $entryObject->getVar('uname');
		$entry['title'] = $entryObject->getVar('title');
		$entry['profileUrl'] = sprintf('%s/userinfo.php?uid=%d', XOOPS_URL, $entryObject->getVar('user_id'));
		$entry['blog_id'] = $entryObject->getVar('blog_id');
		$entry['cat_title'] = (isset($catbox[$entryObject->getVar('cat_id')])) ? $catbox[$entryObject->getVar('cat_id')] : '' ;
		$entry['contents'] = xoops_substr(strip_tags($entryObject->getVar('contents','s',$entryObject->getVar('blog_id'),'index')), 0, 40);
		$entry['comments'] = $entryObject->getVar('comments');
		$entry['trackbacks'] = $entryObject->getVar('trackbacks');
		$blog['entries'][] = $entry;
	}
	$blog['lang_blogtotal'] = sprintf(_MD_WEBLOG_THEREAREINTOTAL, $count);
    $blog['user_id'] = $user_id;
	$blog['cat_id'] = $cat_id;
	$blog['datamonth'] = $date;

	// add page navigator if entries > per page
	if ( $count > $numperpage ) {
  		$uri='';
  		if ($user_id>0) {
    		$uri .= 'user_id='.$user_id;
  		}
		if( intval($date) > 0 ){
			$uri .= '&amp;date='. $date ;
		}
		if( intval($cat_id) > 0 ){
			$uri .= '&amp;cat_id='. $cat_id ;
		}
		include_once XOOPS_ROOT_PATH.'/class/pagenav.php';
		$nav = new XoopsPageNav($count, $numperpage, $start, 'start', $uri);
		$blog['pagenavi'] = $nav->renderNav();
	} else {
		$blog['pagenavi'] = '';
	}	
	
	return $blog;
}


?>