<?php
/*
 * $Id: post.php 280 2007-06-05 02:57:36Z hodaka $
 * Copyright (c) 2003 by Hiro SAKAI <http://wellwine.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once XOOPS_ROOT_PATH.'/class/xoopstree.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblog.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblogcategories.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblogtrackback.php';
require_once dirname(dirname(__FILE__)).'/class/class.notification.php';
require_once dirname(dirname(__FILE__)).'/include/gtickets.php';

$weblog =& Weblog::getInstance();
$weblogcat =& WeblogCategories::getInstance();
$tb_operator =& Weblog_Trackback_Operator::getInstance() ;

function &getEntry($post) {
    global $xoopsModuleConfig ;

    $weblog =& Weblog::getInstance();

    $permission_group = "" ;
    if( isset($post['permission_group']) && is_array($post['permission_group']) ){
        $permission_group = '|' . implode("|" , $post['permission_group']) . '|' ; 
    }else{
        $permission_group = ( isset($post['permission_group']) ) ? $post['permission_group'] : "" ;
    }

    $entry = $weblog->newInstance();
    $entry->setVar('blog_id', $post['blog_id']);
    $entry->setVar('user_id', $post['user_id']);
    $entry->setVar('cat_id', $post['cat_id']);
    $entry->setVar('created', $post['created']);
    $entry->setVar('title', $post['title']);
    if( isset($post['ent_trackbackurl']) )
      $entry->setVar('ent_trackbackurl', $post['ent_trackbackurl']);
    $entry->setVar('contents', $post['contents']);
    $entry->setVar('private', ! empty($post['private']) ? 'Y' : 'N');
    $entry->setVar('permission_group', $permission_group);
    $entry->setVar('updateping', ! empty($post['updateping']) ? 1 : 0);
    $entry->setVar('specify_created', ! empty($post['specify_created']) ? 1 : 0);
    // dohtml check 
    if( $GLOBALS['xoopsModuleConfig']['disable_html'] ){
        $entry->setVar('dohtml', 0);
        $entry->setVar('dobr', 1);
    }else{
        $entry->setVar('dohtml', empty($post['dohtml']) ? 1 : 0);
        $entry->setVar('dobr', empty($post['dobr']) ? 0 : 1);
    }
    return $entry;
}

function weblog_confirm($hiddens, $action, $msg, $submit='', $back=false) {
    global $xoopsGTicket ;
    $submit = ($submit != '') ? trim($submit) : _SUBMIT;
    echo '<div class="confirmMsg"><h4>'.$msg.'</h4><form method="post" action="'.$action.'">';
    $input_hidden = "" ;
    foreach ($hiddens as $name => $value) {
        if (is_array($value)) {
            foreach ($value as $caption => $newvalue) {
                $input_hidden .= '<input type="radio" name="'.$name.'" value="'.$newvalue.'" /> '.$caption;
            }
            $input_hidden .= '<br />';
        } else {
            $input_hidden .= '<input type="hidden" name="'.$name.'" value="'.$value.'" />';
        }
    }
    echo $input_hidden . '<input type="submit" name="continue" value="'.$submit.'" /></form>';
    if( $back ){
        $input_hidden_back = "" ;
        if( isset($hiddens['op']) )
            unset($hiddens['op']) ;
        foreach ($hiddens as $name => $value) {
            $input_hidden_back .= '<input type="hidden" name="'.$name.'" value="'.$value.'" />';
        }
       echo '<form method="post" action="'.$action.'">' . $input_hidden_back . '<input type="submit" name="preview" value="'._CANCEL.'">' ;
    }
    echo '</div>';
}

if (is_object($xoopsUser)) {
    $isAdmin = $xoopsUser->isAdmin($xoopsModule->mid());
    $currentuid = $xoopsUser->getVar('uid');   
} else {
    $isAdmin = false;
    $currentuid = 0;
}

// Check to ensure this user can post. Anonymous reject. Admin always OK.
require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';

if( !$isAdmin && (! $currentuid || ! checkprivilege( "edit" , $xoopsModule->dirname() ) ) ){
    redirect_header(sprintf('%s/modules/%s/index.php', XOOPS_URL, $xoopsModule->dirname()),
                    5, _MD_WEBLOG_ANON_CANNOT_POST_SORRY);
    exit();
}

// change specify date to created time.
$offset = ( strtolower(get_class($xoopsUser)) == "xoopsuser" ) ? $xoopsUser->timezone() - $GLOBALS['xoopsConfig']['server_TZ'] : 0 ;
if( isset($_POST['created_date']['date']) && is_array($_POST['created_date'])){
    $_POST['created'] = strtotime($_POST['created_date']['date']) + $_POST['created_date']['time'] - ( $offset * 3600 );
}

// Save the post
if (!empty($_POST['post'])) {
  	if ( ! $xoopsGTicket->check(true,'weblogD3_admin') ) {
     	redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
  	}
  	$entry =& getEntry($_POST);
    if ($entry->getVar('cat_id') <= 0 || strlen($entry->getVar('contents', 'n')) < $xoopsModuleConfig['minentrysize']) {
        if($entry->getVar('cat_id') <= 0)
            $msg = _MD_WEBLOG_CATEGORY_REQUIRED;
        else
            $msg = sprintf(_MD_WEBLOG_POST_TOO_SMALL, $xoopsModuleConfig['minentrysize'], strlen($entry->getVar('contents', 'n')));
        // Include the page header
        include(XOOPS_ROOT_PATH.'/header.php');
        weblog_confirm(array('blog_id'=>$entry->getVar('blog_id'),
                         'private'=>$entry->isPrivate(),
                         'dohtml'=>!$entry->doHtml(),
                         'dobr'=>$entry->doBr(),
                         'updateping'=>$entry->isUpdateping(),
                         'specify_created'=>$entry->isSpecifycreated(),
                         'user_id'=>$entry->getVar('user_id'),
                         'cat_id'=>$entry->getVar('cat_id'),
                         'created'=>$entry->getVar('created'),
                         'title'=>$entry->getVar('title', 'f'),
                         'contents'=>$entry->getVar('contents', 'f'),
                         'ent_trackbackurl'=>$entry->getVar('ent_trackbackurl'),
                         'permission_group'=>$entry->getVar('permission_group'),
                         'XOOPS_G_TICKET' => $xoopsGTicket->issue( __LINE__, 1800, 'weblogD3_admin' ),
                         'continue'=>1
                       ),
                       'post.php',
                       $msg,
                       _MD_WEBLOG_CONTINUE_EDITING
        );
        // Include the page footer
        include(XOOPS_ROOT_PATH.'/footer.php');
        exit();
    }

	$pageUri = sprintf('%s/modules/%s/details.php?blog_id=', XOOPS_URL, $mydirname);

  	if ($entry->getVar('blog_id') > 0) {
    	$e_entry = $weblog->getEntry($entry->getVar('user_id'), $entry->getVar('blog_id'));

    	$old_trackbackurl = $tb_operator->handler->getTrackbackurl_string( $entry->getVar('blog_id') , "transmit" ) ;

    	$isEditable = ($e_entry->getVar('user_id')==$currentuid || $isAdmin);
    	if ($isEditable) {
      		$e_entry->setVar('title', $entry->getVar('title', 'n'));
      		$e_entry->setVar('cat_id', $entry->getVar('cat_id'));
      		$e_entry->setVar('created', $entry->getVar('created'));
      		$e_entry->setVar('contents', $entry->getVar('contents', 'n'));
      		$e_entry->setVar('ent_trackbackurl', $entry->getVar('ent_trackbackurl' , 'n'));
      		$e_entry->setVar('private', $entry->getVar('private', 'n'));
      		$e_entry->setVar('dohtml', $entry->getVar('dohtml'));
      		$e_entry->setVar('dobr', $entry->getVar('dobr'));
      		$e_entry->setVar('updateping', $entry->getVar('updateping'));
      		$e_entry->setVar('specify_created', $entry->getVar('specify_created'));
      		$e_entry->setVar('permission_group', $entry->getVar('permission_group'));
      		$ret = $weblog->saveEntry($e_entry);
      		if ($ret) {
          		$goodPost = true;
      		} else {
          		$goodPost = false;
      		}
    	} else {
      		$goodPost = false;
    	}
    	$pageUri .= $entry->getVar('blog_id');
  	} else {
//    $entry->setVar('created', time());    // comment out as change created function added
    	$old_trackbackurl = '' ;
    	$entry->setVar('user_id', $currentuid);
    	$ret = $weblog->saveEntry($entry);

    	if ($ret) {
        	$goodPost = true;
    	} else {
        	$goodPost = false;
    	}

//	$pageUri = sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $mydirname, $entry->getVar('blog_id'));
		$pageUri .= $entry->getVar('blog_id');

    	// Send notifications only if the entry not private.
    	if ($ret && $entry->isPrivate()==false) {
//  		$notification_handler =& xoops_gethandler('notification'); // for d3
			$db =& Database::getInstance();
  			$notification_handler = new MyXoopsNotificationHandler($db);

			// override the mail_template_dir for d3
			$language = empty( $xoopsConfig['language'] ) ? 'english' : $xoopsConfig['language'] ;
			if( file_exists( "$mydirpath/language/$language/mail_template/" ) ) {
				// user customized language file
				$notification_handler->template_dir_ = "$mydirpath/language/$language/mail_template/" ;
			} else if( file_exists( "$mytrustdirpath/language/$language/mail_template/" ) ) {
				// default language file
				$notification_handler->template_dir_ = "$mytrustdirpath/language/$language/mail_template/";
			} else {
				// fallback english
				$notification_handler->template_dir_ = "$mytrustdirpath/language/english/mail_template/";
			}

    		$entry_category =& $weblogcat->getCategory($entry->getVar('cat_id'));
    		$tags = array('TITLE'=>$entry->getVar('title'),
                       'CAT_TITLE'=>$entry_category->getVar('cat_title'),
                       'BLOGGER_NAME'=>$xoopsUser->getVar('uname'),
                       'PAGE_URI'=>$pageUri);
			$notification_handler->triggerEvent('blog', 0, 'add' , $tags);
			$notification_handler->triggerEvent('category', $entry->getVar('cat_id'), 'add' , $tags);
			$notification_handler->triggerEvent('blogger', $xoopsUser->getVar('uname'), 'add' , $tags);
    	}
  	}

  	/**
   	 * If they did not affect any rows, they were probably trying to update
     * an entry that was not theirs. So check!
     */
  	if ($goodPost) {
    	// trackback post
    	$trackback_result_msg = "" ;
    	if( trim($entry->getVar('ent_trackbackurl' , 'n')) || $old_trackbackurl ) {
//        $blog_name = $xoopsModule->name() . " - " . sprintf(_MD_WEBLOG_WHOS_BLOG,$xoopsUser->getVar('uname','E')) . " - " . $xoopsConfig['sitename'] ;
        	$before_bn = array('{MODULE_NAME}','{USER_NAME}','{SITE_NAME}') ;
        	$after_bn = array($xoopsModule->name(), $xoopsUser->getVar('uname','E'), $xoopsConfig['sitename']) ;
       		$blog_name = str_replace($before_bn, $after_bn, $xoopsModuleConfig['transmit_blogname']) ;
        	$blog_url = sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $xoopsModule->dirname(),$entry->getVar('blog_id')) ;
        	$tb_operator->Create_Trackback_Data( $entry , $blog_name , $blog_url ) ;
        	$trackback =& $tb_operator->newInstance() ;
        	foreach( $tb_operator->Get_Trackback_Url( $entry , $old_trackbackurl ) as $trackback_url=>$type ){
            	if( $type=="add" ){
                	$tb_operator->Create_Trackback_Data( $entry , $blog_name , $blog_url ) ;
                	if( $tb_operator->Weblog_Post_Trackback( $trackback_url ) ){
                    	// get trackback as quote .
                    	$response_xml = $tb_operator->Get_RSS_from_trackback_URL( $trackback_url ) ;
                    	$tb_rss_data = $tb_operator->Parse_XML( $response_xml ) ;
                    	$tb_operator->Set_Trackback_Values( $trackback , $tb_rss_data , $trackback_url ,  "transmit" , $entry ) ;
                    	$tb_operator->saveTrackback($trackback) ;
                	}
            	}elseif( $type=="del" ){
                	$tb_operator->removeTrackback( $entry->getVar('blog_id') , $trackback_url , "transmit") ;
            	}
       		}

        	$trackback_result_msg = $tb_operator->Xoops_Weblog_Msg() ;
        	if( $trackback_result_msg ){
           	 	$trackback_result_msg =  "<br />\n---- &nbsp; Trackback &nbsp; ----\n<br />\n" . $trackback_result_msg . "<br />" ;
        	}
    	}
    	// trackback(received) delete
    	if( isset($_POST['delete_trackback']) && is_array($_POST['delete_trackback']) ){
        	$tb_del_num = 0 ;
        	foreach( $_POST['delete_trackback'] as $tb_url ){
            	if( ! empty($tb_url) && $tb_operator->removeTrackback( $entry->getVar('blog_id') , $tb_url , "received" ) ){
               	 $tb_del_num-- ;
            	}
        	}
        	if( $tb_del_num != 0 )
            	$weblog->handler->incrementTrackbacks( $entry->getVar('blog_id') , $tb_del_num ) ;
    	}
    	// common ping
    	$common_ping_result_msg = "" ;
    	if( $entry->isUpdateping() ){
			require_once dirname(dirname(__FILE__)).'/class/class.commonping.php';
        	$weblog_url = sprintf('%s/modules/%s/', XOOPS_URL, $mydirname ) ;
        	if( ! isset($blog_name) )
            	$blog_name = $xoopsModule->name() . " - " . sprintf(_MD_WEBLOG_WHOS_BLOG,$xoopsUser->getVar('uname','E')) . " - " . $xoopsConfig['sitename'] ;
        	$Common_Updateping =& new Weblog_Commonping( $blog_name ,  $weblog_url ) ;
//        $commonping_server_file = sprintf('%s/modules/%s/language/%s/commonping_servers.inc.php', 
//                                                                    XOOPS_ROOT_PATH, $xoopsModule->dirname() , $xoopsConfig['language']) ;
//			$commonping_server_file = _MD_WEBLOG_COMMONPING_SERVERS;
            $commonping_server_file = preg_replace("/[\s]+/", "|", $GLOBALS['xoopsModuleConfig']['updateping_url']);
        	$common_ping_result_msg = $Common_Updateping->xoops_weblog_commonping_process( $commonping_server_file ) ;
        	$common_ping_result_msg =  "\n---- &nbsp; Update &nbsp; Ping &nbsp; ----\n" . $common_ping_result_msg;
    	}
    	// redirect
    	redirect_header($pageUri, 2, $trackback_result_msg . $common_ping_result_msg . _MD_WEBLOG_ENTRY_POSTED );
    	exit();
  	} else {
    	redirect_header(sprintf('%s/modules/%s/index.php', XOOPS_URL, $xoopsModule->dirname()),
                    5, _MD_WEBLOG_ANON_CANNOT_POST_SORRY);
    	exit();
  	}
} else if (!empty($_POST['delete']) || (!empty($_POST['op']) && $_POST['op'] == 'delete')) {
  	if ( ! $xoopsGTicket->check(true,'weblogD3_admin') ) {
    	redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
  	}
  	$entry =& getEntry($_POST);
  	if (!empty($_POST['ok'])) {
    	// After delete, return the user to the user's blog they were reading.
    	$link = sprintf('%s/modules/%s/index.php?user_id=%d',
                    XOOPS_URL, $xoopsModule->dirname(), $entry->getVar('user_id'));
    	$isEditable = ($entry->getVar('user_id')==$currentuid || $isAdmin);
    	if ($isEditable) {
      		$ret = $weblog->removeEntry($entry->getVar('blog_id'));
      		if ($ret) {
        		// delete trackbacks 
        		$tb_operator->removeTrackback( $entry->getVar('blog_id') ) ;
        		xoops_comment_delete($xoopsModule->getVar('mid'), $entry->getVar('blog_id'));
        		xoops_notification_deletebyitem($xoopsModule->getVar('mid'),
                                        'blog_entry', $entry->getVar('blog_id'));
        		redirect_header($link, 2 ,_MD_WEBLOG_BLOG_DELETED);
      		} else {
        		redirect_header($link, 5 ,_MD_WEBLOG_BLOG_NOT_DELETED);
      		}
    	} else {
      		redirect_header($link, 5 ,_MD_WEBLOG_BLOG_NOT_DELETED); // TODO
    	}
  	} else {
    	require(XOOPS_ROOT_PATH.'/header.php');
    	weblog_confirm(array(
                        'blog_id' => $entry->getVar('blog_id'),
                        'private'=>$entry->isPrivate(),
                        'dohtml'=>!$entry->doHtml(),
                        'dobr'=> $entry->doBr(),
                        'updateping'=>$entry->isUpdateping(),
                        'specify_created'=>$entry->isSpecifycreated(),
                        'user_id' => $entry->getVar('user_id'),
                        'cat_id' => $entry->getVar('cat_id'),
                        'created' => $entry->getVar('created'),
                        'title' => $entry->getVar('title', 'n'),
                        'contents' => $entry->getVar('contents', 'n'),
                        'ent_trackbackurl'=>$entry->getVar('ent_trackbackurl'),
                        'permission_group'=>$entry->getVar('permission_group'),
                        'XOOPS_G_TICKET' => $xoopsGTicket->issue( __LINE__, intval($xoopsModuleConfig['GTicket_timeout'])*60, 'weblogD3_admin' ),
                        'op' => 'delete',
                        'ok' => 1),
                  'post.php', sprintf(_MD_WEBLOG_CONFIRM_DELETE, stripslashes($entry->getVar('title'))) , false ,true );
    	require(XOOPS_ROOT_PATH.'/footer.php');
  	}
} else {
  	// Edit/Create/Preview the post
  	if( ! empty($_POST['preview']) || ! empty($_POST['continue']) ){  // in case of Preview|Continue check GTicket
    	if ( ! $xoopsGTicket->check(true,'weblogD3_admin') )
       	redirect_header(XOOPS_URL.'/',3,$xoopsGTicket->getErrors());
  	}
  	$blog_id=!empty($_GET['blog_id']) ? intval($_GET['blog_id']) : 0;
  	if ($blog_id>0 && empty($_POST['preview'])) {    // edit mode
    	$entry =& $weblog->getEntry( $currentuid, $blog_id, (!$isAdmin)?$currentuid:0 ) ;
    	if( empty($entry) ){
        	redirect_header(sprintf('%s/modules/%s/index.php', XOOPS_URL, $xoopsModule->dirname()),
                    5, _MD_WEBLOG_CANNOT_EDIT);
        	exit() ;
    	}
    	// for validate.js
        //$selbox = $weblogcat->getMySelectBox($entry->getVar('cat_id'), 1);
        $form_cat_id = $entry->getVar('cat_id');
    	// add trackback data
    	$tb_operator =& Weblog_Trackback_Operator::getInstance() ;
    	$ent_trackback = $tb_operator->handler->getTrackbackurl_string( $blog_id , 'transmit' ) ;
    	$entry->setVar( 'ent_trackbackurl' , $ent_trackback );
    	$received_trackback = $tb_operator->handler->get( $blog_id , 'received' ) ;
  	} elseif (!empty($_POST['preview']) || !empty($_POST['continue'])) {    // editting mode
    	$_POST['title'] = stripslashes($_POST['title']);
    	$_POST['contents'] = stripslashes($_POST['contents']);
    	$entry =& getEntry($_POST);
        // for validate.js
    	//$selbox = $weblogcat->getMySelectBox($entry->getVar('cat_id'),1);
        $form_cat_id = $entry->getVar('cat_id');
    	// add trackback data
    	$tb_operator =& Weblog_Trackback_Operator::getInstance() ;
    	$received_trackback = $tb_operator->handler->get( $entry->getVar('blog_id') , "received" ) ;
  	} else {    // first post
    	$entry = $weblog->newInstance();
    	$entry->setVar('user_id', -1);
        // for validate.js
    	//$selbox = $weblogcat->getMySelectBox(0,1);
        $form_cat_id = 0;
    	$entry->setVar( 'permission_group' , $xoopsModuleConfig['default_permission'] );
  	}

    // read all the categories
    $all_categories =& $weblogcat->getObjects(null, true);
    // get the permitted cat_ids
    $permed = getPermedIds($all_categories, true);
    // make category tree array for selbox
//    $cat_array = $weblogcat->getChildTreeArray();
    $cat_array = getChildTreeArray($all_categories, $permed);
    $catselarray = array();
    $catselarray[''] = _MD_WEBLOG_SELECT_CATEGORY;
    $myts =& MyTextSanitizer::getInstance();
    foreach ( $cat_array as $cat ) {
        $catselarray[intval($cat['cat_id'])] = substr(str_replace('.','--',$cat['prefix']), 2).'&nbsp;'.$myts->makeTboxData4Show($cat['cat_title']);
    }
    $form['catselarray'] = $catselarray;

  	$xoopsOption['template_main'] = $mydirname . '_main_post.html';
  	include_once XOOPS_ROOT_PATH."/include/xoopscodes.php";

  	if( isset($received_trackback) && is_array($received_trackback) && count($received_trackback)>0 ){
      	$received_trackback_url_array = array();
      	foreach( $received_trackback as $trackback_obj ){
          	$received_trackback_url_array[] = $trackback_obj->getVar('tb_url') ;
      	}
      	$entry->setVar( 'delete_trackback' , $received_trackback_url_array ) ; 
  	}

  	// Include the page header
  	include(XOOPS_ROOT_PATH.'/header.php');
  
  	// Generate our form promatically
  	include_once XOOPS_ROOT_PATH."/class/xoopsformloader.php";
//	require_once dirname(dirname(__FILE__)).'/include/myformdatetime.php';
//	require_once dirname(dirname(__FILE__)).'/include/myformtextdateselect.php';

  	$blog_form = new XoopsThemeForm(_MD_WEBLOG_POST, 'weblogForm', "post.php");
	$form['user_id'] = $entry->getVar('user_id');
	$form['blog_id'] = $entry->getVar('blog_id');
	$form['hidden_ticket'] = $xoopsGTicket->issue( __LINE__ , intval($xoopsModuleConfig['GTicket_timeout'])*60 , 'weblogD3_admin' );
	$form['ticket_timeout'] = sprintf(_MD_WEBLOG_POST_TIMEOUT, intval($xoopsModuleConfig['GTicket_timeout']));
  	if ($xoopsModuleConfig['minentrysize'] > 0) {
		$form['min_entrysize'] = sprintf(_MD_WEBLOG_POST_MUST_BE, $xoopsModuleConfig['minentrysize']);
  	}
  	if( $xoopsModuleConfig['disable_html'] ){
		$form['no_html'] = _MD_WEBLOG_FORBIDDEN_HTML_TAGS;
  	}
	$form['title'] = $entry->getVar('title', 'e');
    // for validate.js
    $blog_form->addElement(new XoopsFormText(_MD_WEBLOG_TITLE,'title',
                                           $xoopsModuleConfig['editorwidth'],
                                           80, $entry->getVar('title', 'e')), true);
//  $form['categories'] = $selbox;
    // for validate.js
    //$blog_form->addElement(new XoopsFormLabel(_MD_WEBLOG_CATEGORY, $selbox), true);
    $selbox = new XoopsFormSelect(_MD_WEBLOG_CATEGORY, 'cat_id', $form_cat_id);
    $selbox->addOptionArray($catselarray);
    $blog_form->addElement($selbox, true);
    

	$form['cat_id'] = (is_object($entry))? $entry->getVar('cat_id', 'e') : 0;
/*    $blog_form->addElement(new XoopsFormDhtmlTextArea(_MD_WEBLOG_CONTENTS,'contents',
                                                    $entry->getVar('contents', 'e'),
                                                    $xoopsModuleConfig['editorheight'],
                                                    $xoopsModuleConfig['editorwidth']), true);*/
    $contents_box = new XoopsFormDhtmlTextArea(_MD_WEBLOG_CONTENTS,'contents',
                                                    $entry->getVar('contents', 'e'),
                                                    $xoopsModuleConfig['editorheight'],
                                                    $xoopsModuleConfig['editorwidth']);
    $contents_box->setExtra('tabindex="54"');
    $contents_box->setExtra('accesskey="C"');
    $blog_form->addElement($contents_box, true);// for validate.js

    // add image manager
    if( isset($xoopsModuleConfig['use_imagemanager']) && $xoopsModuleConfig['use_imagemanager'] ){
        $imagemanager_valid = false ;
        // check GD2 module extension is loaded or not.
        if( function_exists("gd_info") ){
            $gd_infomation = gd_info() ;
            if( preg_match('/2\./', $gd_infomation['GD Version']) )    // GD version 2 is required
                $imagemanager_valid = true ;
        }
        if( $imagemanager_valid ){
            $imagemanager_tag = sprintf('<img onmouseover=\'style.cursor="hand"\' onclick=\'javascript:openWithSelfMain("%s/modules/%s/weblog-imagemanager.php?target=contents","imgmanager",400,430);\' src="%s/modules/%s/images/weblog_imagemanager.gif" alt="image" />' ,
                                                            XOOPS_URL , $xoopsModule->dirname() , XOOPS_URL , $xoopsModule->dirname() );
        }else{
            $imagemanager_tag = _MD_WEBLOG_WEBLOG_IMAGEMANAGER_CAUTION ;
        }
		$form['imagemanager_valid'] = $imagemanager_valid;
    }

    // options check box
    if( ! $xoopsModuleConfig['disable_html'] ){
		$form['dohtml'] = 1 - $entry->doHtml();
		$form['dobr'] = $entry->doBr();
    }
	$form['private'] = $entry->isPrivate();
	$form['updateping'] = $entry->isUpdateping();

    // options check box
//    $checkbox_tray = new XoopsFormElementTray(_MD_WEBLOG_OPTIONS ,'<br />');
//    $checkbox_publish = new myXoopsFormDateTime(_MD_WEBLOG_SPECIFY_TIME_DSC, 'created_date', 15, $entry->getVar('created')) ;
//        $checkbox_tray->addElement($checkbox_publish);
//    $blog_form->addElement($checkbox_publish);

	$form['specify_created'] = $entry->isSpecifycreated();
	$form['created'] = $entry->getVar('created', 'e');

    // trackback url textbox
	$form['ent_trackbackurl'] = $entry->getVar('ent_trackbackurl', 'e');
    // received trackback administrator tray
    if( isset($received_trackback) && is_array($received_trackback) && count($received_trackback)>0 ){
		$trackbacks = array();
        foreach( $received_trackback as $key=>$tb_obj ){
            $checked = ( isset($_POST['delete_trackback'][$key]) ) ? true : false ;
			$trackback['tb_delete'] = $checked;
			$trackback['tb_url'] = $tb_obj->getVar('tb_url');
			$trackback['tb_title'] = htmlspecialchars(xoops_substr($tb_obj->getVar('title','n').' : '.$tb_obj->getVar('description','n'),0,60)."...");
			$trackbacks[] = $trackback;
        }
		$form['recvd_trackbacks'] = $trackbacks;
    }
  	// permission control
  	if( isset($xoopsModuleConfig['use_permissionsystem']) && $xoopsModuleConfig['use_permissionsystem'] ){
    	$member_handler =& xoops_gethandler('group');
    	$groups =& $member_handler->getObjects();
    	$group_option = array() ;
    	$group_array = array() ;
    	foreach( $groups as $group ){
        	if( $group->getVar('groupid') == 1 ) continue ;
        	$group_option[$group->getVar('groupid')] = $group->getVar('name') ;
        	$group_array[] = $group->getVar('groupid') ;
    	}
    	if( is_array($entry->getVar('permission_group','n')) ){
       		$default_permission = $entry->getVar('permission_group','n') ;
    	}else{
       		if( $entry->getVar('permission_group','n') == "all" ){
           		$default_permission = $group_array ;
       		}else{
           		$default_permission = explode('|',$entry->getVar('permission_group','n')) ;
       		}
    	}

    	$form['permission_group'] = $group_option;
    	$form['permission_group_value'] = $default_permission;
  	}

	$form['currentuid'] = $currentuid; 
  	if ($entry->getVar('blog_id') > 0 && $isAdmin || $currentuid == $entry->getVar('user_id')) {
		$form['can_delete'] = true;
  	}
	$blog_form->assign($xoopsTpl);
//echo '<pre>';var_dump($xoopsTpl->get_template_vars('weblogForm'));echo '</pre>';exit;

  	if (!empty($_POST['preview'])) {
    	$use_avatar = 0;
    	$avatar_img = '';
    	$avatar_width = 0;
    
    	if ($xoopsModuleConfig['showavatar']) {
      		$avatar = $xoopsUser->getVar('user_avatar', 'E');
      		if (!empty($avatar) && $avatar != 'blank.gif') {
        		$use_avatar = 1;
        		$avatar_img = sprintf('%s/%s', XOOPS_UPLOAD_URL, $avatar);
//        $dimension = ( ini_get('allow_url_fopen') ) ? getimagesize($avatar_img) : "" ;
//        $avatar_width = ( is_array($dimension) ) ? $dimension[0] : "" ;
      		}
    	}

    	$xoopsTpl->assign('preview', $entry->getVar('contents', 's'));
    	$xoopsTpl->assign('use_avatar', $use_avatar);
    	$xoopsTpl->assign('avatar_width', $avatar_width);
    	$xoopsTpl->assign('avatar_img', $avatar_img);
    	$xoopsTpl->assign('title', $entry->getVar('title', 's'));
    	$xoopsTpl->assign('is_preview',1);
    	$xoopsTpl->assign('sample_date', formatTimestamp(time(),
                                                     $xoopsModuleConfig['dateformat'],
                                                     $xoopsConfig['default_TZ']));
        $page_subtitle = _MD_WEBLOG_POST_PREVIEW;
  	} else {
    	$xoopsTpl->assign('is_preview',0);
    	$xoopsTpl->assign('title','');
    	$xoopsTpl->assign('preview','');
    	$xoopsTpl->assign('sample_date','');
        $page_subtitle = _MD_WEBLOG_POST_BLOG;
  	}

    $xoopsTpl->assign('page_title', $xoopsModule->name());
    $xoopsTpl->assign('page_subtitle', $page_subtitle);
    $xoopsTpl->assign('mydirname', $mydirname);
    // for xugj_assign.php
    $breadcrumbs[] = array('name'=>$xoopsModule->name(), 'url'=>XOOPS_URL.'/modules/'.$mydirname.'/'); 
    $breadcrumbs[] = array('name'=>$page_subtitle, 'url'=>'');
    $xoopsTpl->assign('xoops_breadcrumbs', $breadcrumbs);
  
	$xoopsTpl->assign('moduleConfig', @$GLOBALS['xoopsModuleConfig']);
	$xoopsTpl->assign('element', $form);

	// xoops_module_header
	$weblog_head = sprintf('<link rel="stylesheet" type="text/css" media="all" href="%s/modules/%s/css/style.css" />'."\n" , XOOPS_URL , $mydirname );

	// for calendar.js
	$jstime = formatTimestamp($entry->getVar('created'), '"F j, Y H:i:s"');
	ob_start();
	include_once XOOPS_ROOT_PATH.'/include/calendarjs.php';
	$contents = ob_get_contents();
	ob_end_clean();
	$xoops_module_header = $xoopsTpl->get_template_vars('xoops_module_header') . $weblog_head . $contents;
	$xoopsTpl->assign('xoops_module_header',$xoops_module_header) ;

  	// Include the page footer
  	include(XOOPS_ROOT_PATH.'/footer.php');
}
?>