<?php
/**
 * $Id: print.php 130 2007-03-09 06:17:24Z hodaka $
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.zive.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once(XOOPS_ROOT_PATH.'/class/template.php');
require_once dirname(dirname(__FILE__)).'/class/class.weblog.php';

// Include our module's language file
if ( file_exists('$mytrustdirpath/language/modinfo.php') ) {
//	require_once(XOOPS_ROOT_PATH.'/modules/'.$xoopsModule->dirname().'/language/'.$xoopsConfig['language'].'/main.php');
  	require_once dirname(dirname(__FILE__)).'/language/$language/modinfo.php';
} else {
//  require_once(XOOPS_ROOT_PATH.'/modules/'.$xoopsModule->dirname().'/language/english/main.php');
  	require_once dirname(dirname(__FILE__)).'/language/english/modinfo.php';
}

// privilege check
require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';
if(  ! checkprivilege( 'read_detail' , $xoopsModule->dirname() ) ){
    redirect_header(sprintf('%s/index.php', XOOPS_URL ), 2, _MD_WEBLOG_CANNOT_READ_SORRY);
    exit();
}

// obtain GET/POST parameters
$blog_id = isset($_GET['blog_id']) ? intval($_GET['blog_id']) : 0;
if ( empty($blog_id) ) {
    redirect_header(sprintf('%s/index.php', XOOPS_URL ));
}

// obtain class instances
$myts =& MyTextSanitizer::getInstance();
$weblog =& Weblog::getInstance();

// Determine the user we are retrieving the blog entries for
$currentuid = is_object($xoopsUser) ? $xoopsUser->getVar('uid','E') : 0;

header ('Content-Type:text/html; charset='._CHARSET);
$tpl = new XoopsTpl();
$tpl->xoops_setTemplateDir(XOOPS_ROOT_PATH.'/themes');
$tpl->xoops_setCaching(2);
$tpl->xoops_setCacheTime(10);

$entryObject = $weblog->getEntry($currentuid, $blog_id);

$tpl->assign('charset', _CHARSET);
$tpl->assign('author', $entryObject->getVar('uname'));
$tpl->assign('sitename', $xoopsConfig['sitename']);
$tpl->assign('description', "");
$tpl->assign('generator', constant('_MI_'.strtoupper($mydirname).'_NAME'));
$tpl->assign('image_url', $xoopsModuleConfig['imgurl']);
$tpl->assign('datetime', formatTimestamp($entryObject->getVar('created'), "l"));
$tpl->assign('blog_title', $entryObject->getVar('title'));
$tpl->assign('lang_date', _MD_WEBLOG_POSTED);
$tpl->assign('lang_author', _MD_WEBLOG_AUTHOR);
$tpl->assign('lang_comesfrom', sprintf(_MD_WEBLOG_COMESFROM, $xoopsConfig['sitename']));
// TODO _MD_WEBLOG_ENTRY_SEPARATOR_DELIMETER, MEMBER_ONLY_READ_DELIMETER
$tpl->assign('contents', $entryObject->getVar('contents','s' , $entryObject->getVar('blog_id') ,'details' ));
$tpl->assign('site_url', XOOPS_URL);
$tpl->assign('lang_parmalink', _MD_WEBLOG_PARMALINK);
$tpl->assign('parmalink', sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $xoopsModule->dirname(), $blog_id));

$tpl->display("db:".$mydirname."_main_print.html");
?>