<?php
/**
 * @version $Id: weblog-atom.php 268 2007-05-27 05:14:33Z hodaka $
 */

require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once(XOOPS_ROOT_PATH.'/class/template.php');
require_once dirname(dirname(__FILE__)).'/class/class.weblog.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblogcategories.php';

// privilege check
require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';
$isAdmin = ( isset($xoopsUser) && is_object($xoopsUser) ) ? $xoopsUser->isAdmin($xoopsModule->mid()) : false ;
if( ! $isAdmin && ! checkprivilege( 'read_index' , $xoopsModule->dirname() ) ){
    exit();
}

// get PEAR::XML_Serializer
require_once dirname(dirname(__FILE__)).'/include/PEAR/XML/Serializer.php';
$item_data = array() ;
$data = array() ;

// obtain GET/POST parameters
$user_id = !empty($_GET['user_id']) ? intval($_GET['user_id']) : 0;

// obtain class instances
$weblog =& Weblog::getInstance();

// obtain configuration parameters
$max = $xoopsModuleConfig['rssmax'];

// Meta tags
$config_handler =& xoops_gethandler('config');
$xoopsConfigMetaFooter =& $config_handler->getConfigsByCat(XOOPS_CONF_METAFOOTER);

// Limit by user?
if ($user_id > 0) {
  $owner = new XoopsUser($user_id);
  $whosBLog = sprintf(_MD_WEBLOG_WHOS_BLOG, $owner->getVar('uname','E'));
  $description = sprintf(_MD_WEBLOG_ENTRIES_FOR, $owner->getVar('uname','E'));
  $link = sprintf('%s/modules/%s/index.php?user_id=%d', XOOPS_URL, $mydirname, $user_id);
} else {
  // No, we must just be getting the last $max entries
  $whosBLog = $xoopsConfig['sitename'];
  $description = $xoopsConfig['slogan'];
  $link = XOOPS_URL.'/';
}

// get category name
$catarray = array();
$weblogcat =& WeblogCategories::getInstance();
$objs =& $weblogcat->handler->getObjects(null, true);
if(count($objs)) {
    foreach($objs as $cat_id => $cat) {
        $catarray[intval($cat_id)] = $cat->getVar('title');
    }
}

// add weblogs item
$results = $weblog->getEntries(0, $user_id, 0, $max);
$sign = ( $xoopsConfig['default_TZ'] >= 0 ) ? "+" : "-" ;
preg_match('@^(?:http://)?([^/]+)@i', XOOPS_URL, $matches);
foreach($results as $entryObject) {
    $item = array() ;
    $data_excerpt = "" ;
    $date = date("Y-m-d", $entryObject->getVar('created')) . "T" .date("H:i:s", $entryObject->getVar('created')) . $sign . sprintf( "%02d:00",abs($xoopsConfig['default_TZ']));
    $description = preg_replace("|<br\s*\/>|i" , "\n" , $entryObject->getVar('contents','s', $entryObject->getVar('blog_id') ,"rss" ) );
    $cat_title = '';
    if(in_array($entryObject->getvar('cat_id'), array_keys($catarray)))
        $cat_title = htmlspecialchars($catarray[$entryObject->getVar('cat_id')], ENT_QUOTES);  
    $item = array(
        'title' => encoding_set( $entryObject->getVar('title', 'e') , 'UTF-8' ),
        'link' => array(
            '_attributes' => array(
                'href' => sprintf('%s/modules/%s/details.php?blog_id=%d', XOOPS_URL, $mydirname, $entryObject->getVar('blog_id')),
                'type' => 'text/html',
                'rel' => 'alternate',
            ),
        ),
        'id' => 'tag:'.$matches[1].','.date("Y", time()).':'.$xoopsModule->getVar('mid').'.'.$entryObject->getVar('blog_id'),
        'published' => $date ,
        'updated' => $date ,
        'author' => array(
            'name' => encoding_set($entryObject->getVar('uname'), 'UTF-8'),
        ),
        'summary' => array(
            encoding_set(xoops_substr(htmlspecialchars(strip_tags($description), ENT_QUOTES),0,WEBLOG_TB_EXCERPT_NUM) , 'UTF-8'),
            '_attributes' => array(
                'type' => 'html',
                'xml:lang' => _LANGCODE,
                'xml:base' => XOOPS_URL
            )
        )
/*        'content' => array(
            '<![CDATA['.encoding_set(htmlspecialchars($description, ENT_QUOTES), 'UTF-8').']]>',
            '_attributes' => array(
                'mode' => 'escaped',
                'type' => 'text/xhtml',
                'xml:lang' => _LANGCODE,
                'xml:base' => XOOPS_URL
                        )
        )*/
/*        'content' => array(
            '<div xmlns="http://www.w3.org/1999/xhtml">'.encoding_set(htmlspecialchars($description, ENT_QUOTES), 'UTF-8').'</div>',
            '_attributes' => array(
                'type' => 'xhtml',
                'xml:lang' => _LANGCODE,
                'xml:base' => XOOPS_URL
            )
        )*/
    );
    $item_data[] = $item ;
}

$options = array(
    'mode' => 'simplexml' ,
    'indent'    => '    ',
    'linebreak' => "\n",
    'typeHints' => false,
    'addDecl'   => true,
    'encoding'  => 'UTF-8',
    'rootName'  => 'feed',
    'rootAttributes' => array(
        'xmlns' => "http://www.w3.org/2005/Atom"
    ),
    'defaultTagName' => 'entry',
    'attributesArray' => '_attributes',
    'cdata' => false,
    'overrideOptions' => false
);

$data = array(
    'title' => encoding_set( $xoopsConfig['sitename'] , 'UTF-8' ).' - '. encoding_set( $xoopsModule->getVar('name') , 'UTF-8'),
    'link' => array(
        '_attributes'=>array(
            'rel' => 'alternate',
            'type'=> 'text/html',
            'href'=> sprintf('%s/modules/%s/', XOOPS_URL , $mydirname),
            'hreflang' => _LANGCODE
        ),
    ),
    'link' => array(
        '_attributes'=>array(
            'rel' => 'self',
            'type'=> 'application/atom+xml',
            'href'=> sprintf('%s/modules/%s/weblog-atom.php', XOOPS_URL , $mydirname)
        ),
    ),
    'updated' => date("Y-m-d", time()) . 'T' .date("H:i:s", time()) . $sign . sprintf( "%02d:00",abs($xoopsConfig['default_TZ'])),
    'author' => array(
        'name' => encoding_set(htmlspecialchars($xoopsConfigMetaFooter['meta_author'], ENT_QUOTES), 'UTF-8'),
    ),
    'id' => 'tag:'.$matches[1].','.date("Y", time()).':'.$xoopsModule->getVar('mid'),
    'rights' => encoding_set(htmlspecialchars($xoopsConfigMetaFooter['meta_copyright'], ENT_QUOTES), 'UTF-8'),
    'generator' => array(
         encoding_set(htmlspecialchars($xoopsConfig['sitename'], ENT_QUOTES), 'UTF-8'),
         '_attributes' => array(
            'uri' => XOOPS_URL
         )
    ),
    'entry' => $item_data,
) ;

$Serializer = &new XML_Serializer($options);
$status = $Serializer->serialize($data);

if (PEAR::isError($status)){
  die($status->getMessage());
}

header('Content-type: application/xml; charset=UTF-8');
echo $Serializer->getSerializedData();
?>