<?php
/**
 * @version $Id: weblog-imagemanager_post.php 96 2006-11-26 11:09:51Z hodaka $
 */
// ------------------------------------------------------------------------- //
//                      myAlbum-P - XOOPS photo album                        //
//                        <http://www.peak.ne.jp/>                           //
//                         compatible with weBLog                              //
//                   http://xoopsdevelopment.tohokuaiki.jp                   //
// ------------------------------------------------------------------------- //

require_once dirname(dirname(__FILE__)).'/include/myalbum_imagemanager/include/read_configs.php';
require_once dirname(dirname(__FILE__)).'/include/myalbum_imagemanager/include/functions.php';
require_once dirname(dirname(__FILE__)).'/include/myalbum_imagemanager/include/draw_functions.php';
require_once dirname(dirname(__FILE__)).'/include/myalbum_imagemanager/class/myuploader.php';
require_once dirname(dirname(__FILE__)).'/include/myalbum_imagemanager/class/myalbum.textsanitizer.php';
require_once dirname(dirname(__FILE__)).'/include/gtickets.php' ;
include_once XOOPS_ROOT_PATH . '/class/xoopstree.php' ;

// check post privilege
require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';
if( ! is_object($xoopsUser) || !$xoopsUser->isAdmin($xoopsModule->mid()) && ( ! checkprivilege( "edit" , $xoopsModule->dirname() ) ) ){
     redirect_header( $mod_url. "/weblog-imagemanager_close.php" , 5 , _MD_WEBLOG_ALBM_MUSTREGFIRST );
	exit() ;
}else{
	$post_privilege = true ;
}

$myts =& MyAlbumTextSanitizer::getInstance() ;
$cattree = new XoopsTree( $table_cat ,"cat_id" , "cat_pid" ) ;

// GET variables
$caller = empty( $_GET['caller'] ) ? '' : $_GET['caller'] ;

// POST variables
$preview_name = empty( $_POST['preview_name'] ) ? '' : $_POST['preview_name'] ;

// check Categories exist
$result = $xoopsDB->query( "SELECT count(cat_id) as count FROM $table_cat" ) ;
list( $count ) = $xoopsDB->fetchRow( $result ) ;
if( $count < 1 ) {
	redirect_header( XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php" , 2 , _MD_WEBLOG_ALBM_MUSTADDCATFIRST ) ;
	exit ;
}

// check file_uploads = on
if( ! ini_get( "file_uploads" ) ) $file_uploads_off = true ;

// get flag of safe_mode
$safe_mode_flag = ini_get( "safe_mode" ) ;

// check or make photos_dir
if( ! is_dir( $photos_dir ) ) {
	if( $safe_mode_flag ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",10,"At first create & chmod 777 '$photos_dir' by ftp or shell.");
		exit ;
	}

	$rs = mkdir( $photos_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",10,"$photos_dir is not a directory");
		exit ;
	} else @chmod( $photos_dir , 0777 ) ;
}

// check or make thumbs_dir
if( $myalbum_makethumb && ! is_dir( $thumbs_dir ) ) {
	if( $safe_mode_flag ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",10,"At first create & chmod 777 '$thumbs_dir' by ftp or shell.");
		exit ;
	}

	$rs = mkdir( $thumbs_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",10,"$thumbs_dir is not a directory");
		exit ;
	} else @chmod( $thumbs_dir , 0777 ) ;
}

// check or set permissions of photos_dir
if( ! is_writable( $photos_dir ) || ! is_readable( $photos_dir ) ) {
	$rs = chmod( $photos_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",5,"chmod 0777 into $photos_dir failed");
		exit ;
	}
}

// check or set permissions of thumbs_dir
if( $myalbum_makethumb && ! is_writable( $thumbs_dir ) ) {
	$rs = chmod( $thumbs_dir , 0777 ) ;
	if( ! $rs ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php",5,"chmod 0777 into $thumbs_dir failed");
		exit ;
	}
}



if( ! empty( $_POST['submit'] ) ) {

	// anti-CSRF
	if( ! xoops_refcheck() ) die( "XOOPS_URL is not included in your REFERER" ) ;

	$submitter = $my_uid ;

	$cid = empty( $_POST['cid'] ) ? 0 : intval( $_POST['cid'] ) ;
	$newid = $xoopsDB->genId( $table_photos."_lid_seq" ) ;

	// Check if cid is valid
	if( $cid <= 0 ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php" , 2 , 'Category is not specified.' ) ;
		exit ;
	}

	// Check if upload file name specified
	$field = $_POST["xoops_upload_file"][0] ;
	if( empty( $field ) || $field == "" ) {
		die( "UPLOAD error: file name not specified" ) ;
	}
//	$field = $_POST['xoops_upload_file'][0] ;

	if( $_FILES[$field]['name'] == '' ) {
		// No photo uploaded

		if( trim( $_POST["title"] ) === "" ) {
			$_POST['title'] = 'no title' ;
		}

		if( $preview_name != '' && is_readable( "$photos_dir/$preview_name" ) ) {
			$tmp_name = $preview_name ;
		} else {
			if( empty( $myalbum_allownoimage ) ) {
				redirect_header( 'weblog-imagemanager_post.php' , 2 , _MD_WEBLOG_ALBM_NOIMAGESPECIFIED ) ;
				exit ;
			} else {
				@copy( "$mod_path/images/pixel_trans.gif" , "$photos_dir/pixel_trans.gif" ) ;
				$tmp_name = 'pixel_trans.gif' ;
			}
		}

	} else if( $_FILES[$field]['tmp_name'] == "" ) {
		// Fail to upload (wrong file name etc.)
		redirect_header( 'weblog-imagemanager_post.php' , 2 , _MD_WEBLOG_ALBM_FILEERROR ) ;
		exit ;

	} else {
		if( $myalbum_canresize ) $uploader = new MyXoopsMediaUploader( $photos_dir , $array_allowed_mimetypes , $myalbum_fsize , null , null , $array_allowed_exts ) ;
		else $uploader = new MyXoopsMediaUploader( $photos_dir , $array_allowed_mimetypes , $myalbum_fsize , $myalbum_width , $myalbum_height , $array_allowed_exts ) ;

		$uploader->setPrefix( 'tmp_' ) ;
		if( $uploader->fetchMedia( $field ) && $uploader->upload() ) {
			// Succeed to upload

			// The original file name will be the title if title is empty
			if( trim( $_POST["title"] ) === "" ) {
				$_POST['title'] = $uploader->getMediaName() ;
			}

			$tmp_name = $uploader->getSavedFileName() ;

		} else {
			// Fail to upload (sizeover etc.)
			include(XOOPS_ROOT_PATH."/header.php");

			echo $uploader->getErrors();
			@unlink( $uploader->getSavedDestination() ) ;

			include( XOOPS_ROOT_PATH . "/footer.php" ) ;
			exit ;
		}
	}

	if( ! is_readable( "$photos_dir/$tmp_name" ) ) {
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php" , 2 , _MD_WEBLOG_ALBM_FILEREADERROR ) ;
		exit ;
	}

	$title = $myts->stripSlashesGPC( $_POST["title"] ) ;
	$date = time() ;
	$ext = substr( strrchr( $tmp_name , '.' ) , 1 ) ;
	$status = 1 ;
	$sql = "INSERT INTO $table_photos (lid, cid, title, ext, submitter, status, date) VALUES ($newid, $cid, '".addslashes($title)."', '$ext', $submitter, $status, $date)";
	$xoopsDB->query( $sql ) or die( "DB error: INSERT photo table" . $sql ) ;
	if( $newid == 0 ) {
		$newid = $xoopsDB->getInsertId();
	}

	myalbum_modify_photo( "$photos_dir/$tmp_name" , "$photos_dir/$newid.$ext" ) ;
	$dim = GetImageSize( "$photos_dir/$newid.$ext" ) ;
	if( $dim ) $xoopsDB->query( "UPDATE $table_photos SET res_x='{$dim[0]}', res_y='{$dim[1]}' WHERE lid='$newid'") ;

	if( ! myalbum_create_thumb( "$photos_dir/$newid.$ext" , $newid , $ext ) ) {
		$xoopsDB->query( "DELETE FROM $table_photos WHERE lid=$newid" ) ;
		redirect_header(XOOPS_URL."/modules/$mydirname/weblog-imagemanager_post.php" , 2 , _MD_WEBLOG_ALBM_FILEREADERROR ) ;
		exit ;
	}

	// Clear tempolary files
	myalbum_clear_tmp_files( $photos_dir ) ;

	$redirect_uri = XOOPS_URL."/modules/$mydirname/weblog-imagemanager_close.php" ;
	redirect_header( $redirect_uri , 2 , _MD_WEBLOG_ALBM_RECEIVED ) ;
	exit ;
}



// Editing Display

echo "<html><head>
	<link rel='stylesheet' type='text/css' media='all' href='".XOOPS_URL."/xoops.css' />
	<link rel='stylesheet' type='text/css' media='all' href='".XOOPS_URL."/modules/system/style.css' />
	<meta http-equiv='content-type' content='text/html; charset='"._CHARSET."' />
	<meta http-equiv='content-language' content='"._LANGCODE."' />
	</head><body>\n" ;

include_once XOOPS_ROOT_PATH.'/class/xoopsformloader.php';
include_once XOOPS_ROOT_PATH.'/include/xoopscodes.php';

$photo = array(
		'cid' => ( empty( $_GET['cid'] ) ? 0 : intval( $_GET['cid'] ) ) ,
		'description' => '' ,
		'title' => ''
) ;

// Show the form
$form = new XoopsThemeForm( _MD_WEBLOG_ALBM_PHOTOUPLOAD , "uploadphoto" , "weblog-imagemanager_post.php?caller=$caller" ) ;
$pixels_text = "$myalbum_width x $myalbum_height" ;
if( $myalbum_canresize ) $pixels_text .= " (auto resize)" ;
$pixels_label = new XoopsFormLabel( _MD_WEBLOG_ALBM_MAXPIXEL , $pixels_text ) ;
if( $myalbum_fsize >= 1000000 ){
	$myalbum_fsize_desc = number_format($myalbum_fsize/1000000 , 1) . "Mbyte" ;
}elseif( $myalbum_fsize >= 1000 ){
	$myalbum_fsize_desc = number_format($myalbum_fsize/1000 , 1) . "Kbyte" ;
}else{
	$myalbum_fsize_desc = $myalbum_fsize ;
}
$size_label = new XoopsFormLabel( _MD_WEBLOG_ALBM_MAXSIZE , $myalbum_fsize_desc . ( empty( $file_uploads_off ) ? "" : ' &nbsp; <b>"file_uploads" off</b>' ) ) ;
$form->setExtra( "enctype='multipart/form-data'" ) ;

$title_text = new XoopsFormText( _MD_WEBLOG_ALBM_PHOTOTITLE , "title" , 50 , 255 , $myts->makeTboxData4Edit( $photo['title'] ) ) ;

$cat_select = new XoopsFormSelect( _MD_WEBLOG_ALBM_PHOTOCAT , "cid" , $photo['cid'] ) ;
$cat_select->addOption( '' , '----' ) ;
$tree = $cattree->getChildTreeArray( 0 , "cat_title" ) ;
foreach( $tree as $leaf ) {
//	$leaf['prefix'] = substr( $leaf['prefix'] , 0 , -1 ) ;
//	$leaf['prefix'] = str_replace( "." , "--" , $leaf['prefix'] ) ;
//	$cat_select->addOption( $leaf['cid'] , $leaf['prefix'] . $leaf['title'] ) ;
	$cat_select->addOption( $leaf['cat_id'] , $leaf['cat_title'] ) ;
}

$file_form = new XoopsFormFile( _MD_WEBLOG_ALBM_SELECTFILE , "photofile" , $myalbum_fsize ) ;
$file_form->setExtra( "size='40'" ) ;

$op_hidden = new XoopsFormHidden( "op" , "submit" ) ;
$counter_hidden = new XoopsFormHidden( "fieldCounter" , 1 ) ;
$preview_hidden = new XoopsFormHidden( "preview_name" , htmlspecialchars( $preview_name ) , ENT_QUOTES ) ;

$submit_button = new XoopsFormButton( "" , "submit" , _SUBMIT , "submit" ) ;
$preview_button = new XoopsFormButton( "" , "preview" , _PREVIEW , "submit" ) ;
$reset_button = new XoopsFormButton( "" , "reset" , _CANCEL , "reset" ) ;
$submit_tray = new XoopsFormElementTray( '' ) ;
$submit_tray->addElement( $submit_button ) ;
$submit_tray->addElement( $reset_button ) ;

$form->addElement( $pixels_label ) ;
$form->addElement( $size_label ) ;
$form->addElement( $title_text ) ;
$form->addElement( $cat_select ) ;
$form->setRequired( $cat_select ) ;
$form->addElement( $file_form ) ;
$form->addElement( $preview_hidden ) ;
$form->addElement( $counter_hidden ) ;
$form->addElement( $op_hidden ) ;
$form->addElement( $submit_tray ) ;
$form->display() ;

echo "</body></html>" ;

?>