<?php
/**
 * @version $Id: weblog-tbkey.php 168 2007-03-22 06:28:17Z hodaka $
 * @brief Generate trackback sending ticket key
 * @author 'hodaka' <hodaka@kuri3.net>
 */

// return key in xml format
function putXML($error, $tbkey='') {
    header('Content-type: text/xml; charset=utf-8');
    $body = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n".
        "<data>\n" .
        "<tbkey>\n".
        "<error>%d</error>\n".
        "<key>%s</key>\n".
        "</tbkey>\n".
        "</data>\n";
    $xml = sprintf($body, $error, $tbkey);
    exit($xml);
}

require_once dirname(dirname(__FILE__)).'/include/header.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblogtrackback.php';
require_once dirname(dirname(__FILE__)).'/class/class.weblog.php';

$tbkey = '';
$error = 1;

$tb_operator =& Weblog_Trackback_Operator::getInstance() ;
$trackback =& $tb_operator->newInstance() ;

// privilege check
if (is_object($xoopsUser)) {
    $isAdmin = $xoopsUser->isAdmin($xoopsModule->mid());
    $currentuid = $xoopsUser->getVar('uid');
    $useroffset = $xoopsUser->timezone() - $xoopsConfig['server_TZ'] ;   
} else {
    $isAdmin = false;
    $currentuid = 0;
    $useroffset = $xoopsConfig['default_TZ'] - $xoopsConfig['server_TZ'] ; 
}

require_once dirname(dirname(__FILE__)).'/include/privilege.inc.php';
if( ! $isAdmin && ! checkprivilege( 'read_detail' , $mydirname)){
//    exit( $tb_operator->getPingXML(false , 'Sorry, you can\'t access this blog'));
    putXML($error, 'Sorry, you can\'t access this blog');
}

// get blog_id
$blog_id = !empty($_POST['blog_id'])? intval($_POST['blog_id']) : 0;
if(empty($blog_id)) {
    putXML($error, 'You sent a invalid id.');
}

// get entry
$weblog =& Weblog::getInstance();
//$entry =& $weblog->handler->get($blog_id);
$entry =& $weblog->getEntry($currentuid, $blog_id, 0, $useroffset);
if(!$entry) {
    putXML($error, 'Blog not found. Invalid id.');
}

// generate trackback ticket key
global $xoopsModuleConfig, $xoopsModule, $xoopsUser ;

$tbkey = md5($_SERVER['REMOTE_ADDR'].time().rand());
$tbkey= substr(base_convert($tbkey, 16, 32),0,12);

// save trackback
$trackback->setVar('blog_id' , $blog_id ) ;
$trackback->setVar('tb_url' , $tbkey ) ;
$trackback->setVar('trackback_created' , time() ) ;
$trackback->setVar('tbkey' , $tbkey ) ;
$trackback->setVar('direction' , 'received' ) ;
$trackback->setNew();
if( $tb_operator->saveTrackback($trackback) )
    $error = 0;
else
    $tbkey = 'Can\'t save the trackback key';
    
// garbage ticket key
$percetage = 5;        // perform garbage at 5%(every 20 times) 
$expiration = 3600*24;  // default 1day
$tb_operator->handler->garbageTrackbackKey($percetage, $expiration);

putXML($error, $tbkey);

?>