<?php
/**
 * $Id: xoops_version.php 315 2007-07-09 05:44:24Z hodaka $
 * @brief v3 dupulicatable weblog module
 * Copyright (c) 2003 by Jeremy N. Cowgar <jc@cowgar.com>
 * Copyright (c) 2003 by Hiro SAKAI (http://wellwine.net/)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * You may not change or alter any portion of this comment or credits
 * of supporting developers from this source code or any supporting
 * source code which is considered copyrighted (c) material of the
 * original comment or credit authors.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

// language file (modinfo.php)
$langmanpath = XOOPS_TRUST_PATH.'/libs/altsys/class/D3LanguageManager.class.php';
if( ! file_exists( $langmanpath ) ) die( 'install the latest altsys' );
require_once( $langmanpath );
$langman =& D3LanguageManager::getInstance();
$langman->read( 'modinfo.php' , $mydirname , $mytrustdirname , false );

$constpref = '_MI_' . strtoupper( $mydirname );

$modversion['name'] = constant($constpref.'_NAME');
$modversion['description'] = constant($constpref.'_DESC');
$modversion['version'] = 1.534;
$modversion['author'] = "";
$modversion['credits'] = "XOOPS Cube System";
$modversion['help'] = "{$mydirname}_help.html";
$modversion['license'] = "GPL see LICENSE";
$modversion['official'] = 0;
$modversion['image'] = 'module_icon.php';
$modversion['dirname'] = $mydirname;

// Any tables can't be touched by modulesadmin.
$modversion['sqlfile'] = false ;
$modversion['tables'] = array() ;

// Admin things
$modversion['hasAdmin'] = 1;
$modversion['adminindex'] = "admin/index.php";
$modversion['adminmenu'] = "admin/admin_menu.php";

// Menu
$modversion['hasMain'] = 1;
// Check user's privilege.
if(is_object(@$GLOBALS['xoopsUser'])) {
    $module_handler = & xoops_gethandler('module');
    $module =& $module_handler->getByDirname($mydirname);
    if(is_object($module) && $module->getVar('isactive')) {
        require_once dirname(__FILE__).'/include/privilege.inc.php';
        require_once dirname(__FILE__).'/include/config.php';

        $isAdmin = $GLOBALS['xoopsUser']->isAdmin($module->getVar('mid'));
        if( $isAdmin || checkprivilege('edit' , $mydirname) ){
            $modversion['sub'][1]['name'] = constant($constpref.'_SMNAME1');
            $modversion['sub'][1]['url'] = 'myblog.php';
            $modversion['sub'][2]['name'] = constant($constpref.'_SMNAME2');
            $modversion['sub'][2]['url'] = 'post.php';
        }
    }
}
$modversion['sub'][3]['name'] = constant($constpref.'_SMNAME3');
$modversion['sub'][3]['url'] = 'archive.php';

// Template
// All Templates can't be touched by modulesadmin.
$modversion['templates'] = array() ;

// Search
$modversion['hasSearch'] = 1;
$modversion['search']['file'] = 'include/search.inc.php';
$modversion['search']['func'] = $mydirname.'_global_search';

// Comments
$modversion['hasComments'] = 1;
$modversion['comments']['pageName'] = 'details.php';
$modversion['comments']['itemName'] = 'blog_id';

$modversion['comments']['callbackFile'] = 'comment_functions.php';
$modversion['comments']['callback']['approve'] = $mydirname.'_com_approve';
$modversion['comments']['callback']['update'] = $mydirname.'_com_update';

// Notifications
$modversion['hasNotification'] = 1;

$modversion['notification']['lookup_file'] = 'notification.php';
$modversion['notification']['lookup_func'] = $mydirname.'_notify_iteminfo';
$i = 0;
$modversion['notification']['category'][$i]['name'] = 'blog';
$modversion['notification']['category'][$i]['title'] = constant($constpref.'_NOTIFY_GLOBAL');
$modversion['notification']['category'][$i]['description'] = constant($constpref.'_NOTIFY_GLOBAL_DSC');
$modversion['notification']['category'][$i]['subscribe_from'] = 'index.php';
$i++;
$modversion['notification']['category'][$i]['name'] = 'category';
$modversion['notification']['category'][$i]['title'] = constant($constpref.'_NOTIFY_CATEGORY');
$modversion['notification']['category'][$i]['description'] = constant($constpref.'_NOTIFY_CATEGORY_DSC');
$modversion['notification']['category'][$i]['subscribe_from'] = 'index.php';
$modversion['notification']['category'][$i]['item_name'] = 'cat_id';
$modversion['notification']['category'][$i]['allow_bookmark'] = 1;
$i++;
$modversion['notification']['category'][$i]['name'] = 'blogger';
$modversion['notification']['category'][$i]['title'] = constant($constpref.'_NOTIFY_BLOGGER');
$modversion['notification']['category'][$i]['description'] = constant($constpref.'_NOTIFY_BLOGGER_DSC');
$modversion['notification']['category'][$i]['subscribe_from'] = 'index.php';
$modversion['notification']['category'][$i]['item_name'] = 'user_id';
$modversion['notification']['category'][$i]['allow_bookmark'] = 1;
$i++;
$modversion['notification']['category'][$i]['name'] = 'detail';
$modversion['notification']['category'][$i]['title'] = constant($constpref.'_NOTIFY_ENTRY');
$modversion['notification']['category'][$i]['description'] = constant($constpref.'_NOTIFY_ENTRY_DSC');
$modversion['notification']['category'][$i]['subscribe_from'] = 'details.php';
$modversion['notification']['category'][$i]['item_name'] = 'blog_id';
$modversion['notification']['category'][$i]['allow_bookmark'] = 1;

$i = 0;
$modversion['notification']['event'][$i]['name'] = 'add';
$modversion['notification']['event'][$i]['category'] = 'blog';
$modversion['notification']['event'][$i]['title'] = constant($constpref.'_NOTIFY_SENT_GLOBAL');
$modversion['notification']['event'][$i]['caption'] = constant($constpref.'_NOTIFY_SENT_GLOBAL_CAP');
$modversion['notification']['event'][$i]['description'] = constant($constpref.'_NOTIFY_SENT_GLOBAL_DSC');
$modversion['notification']['event'][$i]['mail_template'] = 'blog_entry';
$modversion['notification']['event'][$i]['mail_subject'] = constant($constpref.'_NOTIFY_SENT_GLOBAL_SBJ');
$i++;
$modversion['notification']['event'][$i]['name'] = 'add';
$modversion['notification']['event'][$i]['category'] = 'category';
$modversion['notification']['event'][$i]['title'] = constant($constpref.'_NOTIFY_SENT_CATEGORY');
$modversion['notification']['event'][$i]['caption'] = constant($constpref.'_NOTIFY_SENT_CATEGORY_CAP');
$modversion['notification']['event'][$i]['description'] = constant($constpref.'_NOTIFY_SENT_CATEGORY_DSC');
$modversion['notification']['event'][$i]['mail_template'] = 'blog_entry';
$modversion['notification']['event'][$i]['mail_subject'] = constant($constpref.'_NOTIFY_SENT_CATEGORY_SBJ');
$i++;
$modversion['notification']['event'][$i]['name'] = 'add';
$modversion['notification']['event'][$i]['category'] = 'blogger';
$modversion['notification']['event'][$i]['title'] = constant($constpref.'_NOTIFY_SENT_BLOGGER');
$modversion['notification']['event'][$i]['caption'] = constant($constpref.'_NOTIFY_SENT_BLOGGER_CAP');
$modversion['notification']['event'][$i]['description'] = constant($constpref.'_NOTIFY_SENT_BLOGGER_DSC');
$modversion['notification']['event'][$i]['mail_template'] = 'blog_entry';
$modversion['notification']['event'][$i]['mail_subject'] = constant($constpref.'_NOTIFY_SENT_BLOGGER_SBJ');

// Config Options
$i=0;
$modversion['config'][$i]['name'] = 'numperpage';
$modversion['config'][$i]['title'] = $constpref.'_NUMPERPAGE';
$modversion['config'][$i]['description'] = $constpref.'_NUMPERPAGEDSC';
$modversion['config'][$i]['formtype'] = 'select';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 10;
$modversion['config'][$i]['options'] = array('5' => 5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '30' => 30, '50' => 50);
$i++;
$modversion['config'][$i]['name'] = 'dateformat';
$modversion['config'][$i]['title'] = $constpref.'_DATEFORMAT';
$modversion['config'][$i]['description'] = $constpref.'_DATEFORMATDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = 'Y/m/d';
$i++;
$modversion['config'][$i]['name'] = 'timeformat';
$modversion['config'][$i]['title'] = $constpref.'_TIMEFORMAT';
$modversion['config'][$i]['description'] = $constpref.'_TIMEFORMATDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = 'g:i a';
$i++;
$modversion['config'][$i]['name'] = 'update_reads_when';
$modversion['config'][$i]['title'] = $constpref.'_UPDATE_READS_WHEN';
$modversion['config'][$i]['description'] = $constpref.'_UPDATE_READS_WHENDSC';
$modversion['config'][$i]['formtype'] = 'select';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$modversion['config'][$i]['options'] = array(constant($constpref.'_UPDATE_READS_WHEN1')=>1,
                                            constant($constpref.'_UPDATE_READS_WHEN2')=>2,
                                            constant($constpref.'_UPDATE_READS_WHEN3')=>3);
$i++;
$modversion['config'][$i]['name'] = 'GTicket_timeout';
$modversion['config'][$i]['title'] = $constpref.'_GTICKETTIMEOUT';
$modversion['config'][$i]['description'] = $constpref.'_GTICKETTIMEOUTDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 60;
$i++;
$modversion['config'][$i]['name'] = 'showavatar';
$modversion['config'][$i]['title'] = $constpref.'_SHOWAVATAR';
$modversion['config'][$i]['description'] = $constpref.'_SHOWAVATARDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'minentrysize';
$modversion['config'][$i]['title'] = $constpref.'_MINENTRYSIZE';
$modversion['config'][$i]['description'] = $constpref.'_MINENTRYSIZEDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 50;
$i++;
$modversion['config'][$i]['name'] = 'editorheight';
$modversion['config'][$i]['title'] = $constpref.'_EDITORHEIGHT';
$modversion['config'][$i]['description'] = $constpref.'_EDITORHEIGHTDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 15;
$i++;
$modversion['config'][$i]['name'] = 'editorwidth';
$modversion['config'][$i]['title'] = $constpref.'_EDITORWIDTH';
$modversion['config'][$i]['description'] = $constpref.'_EDITORWIDTHDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 60;
$i++;
$modversion['config'][$i]['name'] = 'adminonly';
$modversion['config'][$i]['title'] = $constpref.'_ONLYADMIN';
$modversion['config'][$i]['description'] = $constpref.'_ONLYADMINDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'userpost_countup';
$modversion['config'][$i]['title'] = $constpref.'_POST_COUNTUP';
$modversion['config'][$i]['description'] = $constpref.'_POST_COUNTUPDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'disable_html';
$modversion['config'][$i]['title'] = $constpref.'_DISABLE_HTML';
$modversion['config'][$i]['description'] = $constpref.'_DISABLE_HTMLDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'transmit_blogname';
$modversion['config'][$i]['title'] = $constpref.'_TB_BLOGNAME';
$modversion['config'][$i]['description'] = $constpref.'_TB_BLOGNAMEDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = '{MODULE_NAME}-{USER_NAME}\'s BLOG-{SITE_NAME}';
// wellwine for read cookie begins
$i++;
$modversion['config'][$i]['name'] = 'expiration';
$modversion['config'][$i]['title'] = $constpref.'_EXPIRATION';
$modversion['config'][$i]['description'] = $constpref.'_EXPIRATIONDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 86400;
// wellwine for rss feed
$i++;
$modversion['config'][$i]['name'] = 'rssshow';
$modversion['config'][$i]['title'] = $constpref.'_RSSSHOW';
$modversion['config'][$i]['description'] = $constpref.'_RSSSHOWDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'rssmax';
$modversion['config'][$i]['title'] = $constpref.'_RSSMAX';
$modversion['config'][$i]['description'] = $constpref.'_RSSMAXDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 10;
$i++;
$modversion['config'][$i]['name'] = 'imgurl';
$modversion['config'][$i]['title'] = $constpref.'_IMGURL';
$modversion['config'][$i]['description'] = $constpref.'_IMGURLDSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = XOOPS_URL.'/images/logo.gif';
$i++;
$modversion['config'][$i]['name'] = 'default_dohtml';
$modversion['config'][$i]['title'] = $constpref.'_OPDOHTML';
$modversion['config'][$i]['description'] = $constpref.'_OPDOHTMLDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'default_dobr';
$modversion['config'][$i]['title'] = $constpref.'_OPDOBR';
$modversion['config'][$i]['description'] = $constpref.'_OPDOBRDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'default_private';
$modversion['config'][$i]['title'] = $constpref.'_OPPRIVATE';
$modversion['config'][$i]['description'] = $constpref.'_OPPRIVATEDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'default_updateping';
$modversion['config'][$i]['title'] = $constpref.'_OPUPDATEPING';
$modversion['config'][$i]['description'] = $constpref.'_OPUPDATEPINGDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'updateping_url';
$modversion['config'][$i]['title'] = $constpref.'_UPDATEPING_URL';
$modversion['config'][$i]['description'] = $constpref.'_UPDATEPING_URL_DSC';
$modversion['config'][$i]['formtype'] = 'textarea';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = constant($constpref.'_UPDATEPING_SERVERS');
$i++;
$modversion['config'][$i]['name'] = 'use_separator';
$modversion['config'][$i]['title'] = $constpref.'_USESEPARATOR';
$modversion['config'][$i]['description'] = $constpref.'_USESEPARATORDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'use_memberonly';
$modversion['config'][$i]['title'] = $constpref.'_USESMEMBERONLY';
$modversion['config'][$i]['description'] = $constpref.'_USESMEMBERONLYDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;
$i++;
$modversion['config'][$i]['name'] = 'use_imagemanager';
$modversion['config'][$i]['title'] = $constpref.'_USEIMAGEMANAGER';
$modversion['config'][$i]['description'] = $constpref.'_USEIMAGEMANAGERDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'use_permissionsystem';
$modversion['config'][$i]['title'] = $constpref.'_USEPERMITSYSTEM' ;
$modversion['config'][$i]['description'] = $constpref.'_USEPERMITSYSTEMDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 0;

$member_handler =& xoops_gethandler('group');
$groups =& $member_handler->getObjects();
$group_option = array() ;
$group_default = array() ;
foreach( $groups as $group ){
    if( $group->getVar('groupid') == 1 ) continue ;
    $group_option[$group->getVar('name')] = $group->getVar('groupid') ;
    $group_default[] = $group->getVar('groupid') ;
}
$i++;
$modversion['config'][$i]['name'] = 'default_permission';
$modversion['config'][$i]['title'] = $constpref.'_DEFAULT_PERMIT';
$modversion['config'][$i]['description'] = $constpref.'_DEFAULT_PERMITDSC';
$modversion['config'][$i]['formtype'] = 'select_multi';
$modversion['config'][$i]['valuetype'] = 'array';
$modversion['config'][$i]['default'] = $group_default;
//  'options' => array('r-r-r'=>'111', 'r-r--'=>'110', 'r----'=>'100', '--r--'=>'010' )
$modversion['config'][$i]['options'] = $group_option;
$i++;
$modversion['config'][$i]['name'] = 'permission_showtitle';
$modversion['config'][$i]['title'] = $constpref.'_PERMIT_SHOWTITLE';
$modversion['config'][$i]['description'] = $constpref.'_PERMIT_SHOWTITLEDSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = 1;
$i++;
$modversion['config'][$i]['name'] = 'privilege_system';
$modversion['config'][$i]['title'] = $constpref.'_PRIVILEGE_SYSTEM';
$modversion['config'][$i]['description'] = $constpref.'_PRIVILEGE_SYSTEMDSC';
$modversion['config'][$i]['formtype'] = 'select';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = 'XOOPS';
$modversion['config'][$i]['options'] = array( 'XOOPS standard system'=>'XOOPS',
                                            'weBLog simple system'=>'weblog' );
$i++;
$modversion['config'][$i]['name'] = 'show_category_list';
$modversion['config'][$i]['title'] = $constpref.'_SHOWCATEGORY';
$modversion['config'][$i]['description'] = $constpref.'_SHOWCATEGORY_DSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '0';
$i++;
$modversion['config'][$i]['name'] = 'category_post_permission';
$modversion['config'][$i]['title'] = $constpref.'_CAT_POSTPERM';
$modversion['config'][$i]['description'] = $constpref.'_CAT_POSTPERM_DSC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '0';
$i++;
$modversion['config'][$i]['name'] = 'category_col';
$modversion['config'][$i]['title'] = $constpref.'_CAT_LISTCOL';
$modversion['config'][$i]['description'] = $constpref.'_CAT_LISTCOL_DSC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '4';
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_photospath';
$modversion['config'][$i]['title'] = $constpref.'_CFG_PHOTOSPATH';
$modversion['config'][$i]['description'] = $constpref.'_CFG_DESCPHOTOSPATH';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = "/uploads/".$mydirname."_photos";
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_thumbspath';
$modversion['config'][$i]['title'] = $constpref.'_CFG_THUMBSPATH';
$modversion['config'][$i]['description'] = $constpref.'_CFG_DESCTHUMBSPATH';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = "/uploads/".$mydirname."_thumbs";
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_width';
$modversion['config'][$i]['title'] = $constpref.'_CFG_WIDTH';
$modversion['config'][$i]['description'] = $constpref.'_CFG_DESCWIDTH';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '1024';
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_height';
$modversion['config'][$i]['title'] = $constpref.'_CFG_HEIGHT';
$modversion['config'][$i]['description'] = $constpref.'_CFG_DESCHEIGHT';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '1024';
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_fsize';
$modversion['config'][$i]['title'] = $constpref.'_CFG_FSIZE';
$modversion['config'][$i]['description'] = $constpref.'_CFG_DESCFSIZE';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '1200000';
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_thumbsize';
$modversion['config'][$i]['title'] = $constpref.'_CFG_THUMBSIZE';
$modversion['config'][$i]['description'] = '';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '140';
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'weblog_myalbum_thumbrule';
$modversion['config'][$i]['title'] = $constpref.'_CFG_THUMBRULE';
$modversion['config'][$i]['description'] = '';
$modversion['config'][$i]['formtype'] = 'select';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = 'b';
$modversion['config'][$i]['options'] = array(
        constant($constpref.'_OPT_CALCFROMWIDTH') => 'w' , constant($constpref.'_OPT_CALCFROMHEIGHT') => 'h' , constant($constpref.'_OPT_CALCWHINSIDEBOX') => 'b' );

// trackback check by hodaka
$i++;
$modversion['config'][$i]['name'] = 'use_tbticket';
$modversion['config'][$i]['title'] = $constpref.'_USE_TBTICKET';
$modversion['config'][$i]['description'] = $constpref.'_USE_TBTICKET_DESC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '1';

if($langman->language == 'japanese' || $langman->language == 'ja_utf8') {
    $i++;
    $modversion['config'][$i]['name'] = 'check_language';
    $modversion['config'][$i]['title'] = $constpref.'_CHECK_LANGUAGE';
    $modversion['config'][$i]['description'] = $constpref.'_CHECK_TRACKBACK_DESC';
    $modversion['config'][$i]['formtype'] = 'select';
    $modversion['config'][$i]['valuetype'] = 'int';
    $modversion['config'][$i]['default'] = 0;
    $modversion['config'][$i]['options'] = array(constant($constpref.'_NO_CHECK_LANGUAGE') => 0,
                                            constant($constpref.'_LANGUAGE_NEEDLETTER1')=>1,
                                            constant($constpref.'_LANGUAGE_NEEDLETTER2')=>2,
                                            constant($constpref.'_LANGUAGE_NEEDLETTER3')=>3);
}
$i++;
$modversion['config'][$i]['name'] = 'spam_word';
$modversion['config'][$i]['title'] = $constpref.'_SPAM_WORDS';
$modversion['config'][$i]['description'] = $constpref.'_SPAM_WORDS_DESC';
$modversion['config'][$i]['formtype'] = 'textarea';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = "oxycodone|lipitor";
$modversion['config'][$i]['options'] = array();
$i++;
$modversion['config'][$i]['name'] = 'check_rbl';
$modversion['config'][$i]['title'] = $constpref.'_CHECK_RBL';
$modversion['config'][$i]['description'] = $constpref.'_CHECK_RBL_DESC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '0';
$i++;
$modversion['config'][$i]['name'] = 'rbllist';
$modversion['config'][$i]['title'] = $constpref.'_RBL_LIST';
$modversion['config'][$i]['description'] = $constpref.'_RBL_LIST_DESC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = "niku.2ch.net|list.dsbl.org|bl.spamcop.net|sbl-xbl.spamhaus.org|all.rbl.jp|opm.blitzed.org|bsb.empty.us|bsb.spamlookup.net";
$i++;
$modversion['config'][$i]['name'] = 'sendmail_to_admin';
$modversion['config'][$i]['title'] = $constpref.'_SEND_TO_ADMIN';
$modversion['config'][$i]['description'] = $constpref.'_SEND_TO_ADMIN_DESC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '0';
$i++;
$modversion['config'][$i]['name'] = 'trackback_notify';
$modversion['config'][$i]['title'] = $constpref.'_TRACKBACK_NOTIFY';
$modversion['config'][$i]['description'] = $constpref.'_TRACKBACK_NOTIFY_DESC';
$modversion['config'][$i]['formtype'] = 'yesno';
$modversion['config'][$i]['valuetype'] = 'int';
$modversion['config'][$i]['default'] = '0';
$i++;
$modversion['config'][$i]['name'] = 'send_address';
$modversion['config'][$i]['title'] = $constpref.'_SEND_ADDRESS';
$modversion['config'][$i]['description'] = $constpref.'_SEND_ADDRESS_DESC';
$modversion['config'][$i]['formtype'] = 'textbox';
$modversion['config'][$i]['valuetype'] = 'text';
$modversion['config'][$i]['default'] = '';

//Blocks
$i=1;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_RECENT_BNAME1');
$modversion['blocks'][$i]['description'] = constant($constpref.'_RECENT_BNAME1_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_recent_blogs_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_recent_blogs_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|10|25|Y/m/d|0|1|0|0|0||0';
$modversion['blocks'][$i]['can_clone'] = true ;
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_LATEST_CONTENT');
$modversion['blocks'][$i]['description'] = constant($constpref.'_LATEST_CONTENT_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_latest_content_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_latest_content_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|10|25|Y/m/d|1|1|1|0|0';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_TOP_WEBLOGS');
$modversion['blocks'][$i]['description'] = constant($constpref.'_TOP_WEBLOGS_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_top_blogs_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_top_blogs_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|10|1|1';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_USERS_WEBLOGS');
$modversion['blocks'][$i]['description'] = constant($constpref.'_USERS_WEBLOGS_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_users_blogs_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_users_blogs_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|5|5|Y/m/d|0|0|0|25|0|0';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_RECENT_TRACKBACKS');
$modversion['blocks'][$i]['description'] = constant($constpref.'_RECENT_TRACKBACKS_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_recent_tb_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_recent_tb_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|5|25|Y/m/d|2';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_RECENT_COMMENTS');
$modversion['blocks'][$i]['description'] = constant($constpref.'_RECENT_COMMENTS_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_recent_comment_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_recent_comment_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|5|25|Y/m/d|2';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_LINKS');
$modversion['blocks'][$i]['description'] = constant($constpref.'_LINKS_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_links_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_links_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'||10|0|1';
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_RECENT_IMAGES');
$modversion['blocks'][$i]['description'] = constant($constpref.'_RECENT_IMAGES_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_recent_image_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_recent_image_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|5|20|0|Y/m/d|0';
// hodaka added category list block
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_CATEGORY_LIST');
$modversion['blocks'][$i]['description'] = constant($constpref.'_CATEGORY_LIST_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_category_list_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_category_list_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|1';
// hodaka added archives block
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_ARCHIVE_LIST');
$modversion['blocks'][$i]['description'] = constant($constpref.'_ARCHIVE_LIST_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_archive_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_archive_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname.'|6';
// hodaka added calendar block
$i++;
$modversion['blocks'][$i]['file'] = 'blocks.php';
$modversion['blocks'][$i]['name'] = constant($constpref.'_CALENDAR');
$modversion['blocks'][$i]['description'] = constant($constpref.'_CALENDAR_DESC');
$modversion['blocks'][$i]['show_func'] = 'b_'.strtolower($mytrustdirname).'_calendar_show';
$modversion['blocks'][$i]['edit_func'] = 'b_'.strtolower($mytrustdirname).'_calendar_edit';
$modversion['blocks'][$i]['template'] = '';
$modversion['blocks'][$i]['options'] = $mydirname;

$modversion['onInstall'] = 'oninstall.php';
$modversion['onUpdate'] = 'onupdate.php';
$modversion['onUninstall'] = 'onuninstall.php';

// keep block's options
if( ! defined( 'XOOPS_CUBE_LEGACY' ) && substr( XOOPS_VERSION , 6 , 3 ) < 2.1 && ! empty( $_POST['fct'] ) && ! empty( $_POST['op'] ) && $_POST['fct'] == 'modulesadmin' && $_POST['op'] == 'update_ok' && $_POST['dirname'] == $modversion['dirname'] ) {
    include dirname(__FILE__).'/include/x20_keepblockoptions.inc.php' ;
}
?>